diff -Nru -x CVS kaffe_orig/libraries/javalib/Makefile.am kaffe/libraries/javalib/Makefile.am
--- kaffe_orig/libraries/javalib/Makefile.am	2003-10-10 10:58:17.000000000 +1300
+++ kaffe/libraries/javalib/Makefile.am	2003-10-11 09:45:48.000000000 +1300
@@ -906,7 +906,6 @@
 	java/beans/EventSetDescriptor.java \
 	java/beans/ExceptionListener.java \
 	java/beans/FeatureDescriptor.java \
-	java/beans/GenericBeanInfo.java \
 	java/beans/IndexedPropertyDescriptor.java \
 	java/beans/IntrospectionException.java \
 	java/beans/Introspector.java \
diff -Nru -x CVS kaffe_orig/libraries/javalib/Makefile.in kaffe/libraries/javalib/Makefile.in
--- kaffe_orig/libraries/javalib/Makefile.in	2003-10-10 10:58:17.000000000 +1300
+++ kaffe/libraries/javalib/Makefile.in	2003-10-11 09:46:26.000000000 +1300
@@ -1187,7 +1187,6 @@
 	java/beans/EventSetDescriptor.java \
 	java/beans/ExceptionListener.java \
 	java/beans/FeatureDescriptor.java \
-	java/beans/GenericBeanInfo.java \
 	java/beans/IndexedPropertyDescriptor.java \
 	java/beans/IntrospectionException.java \
 	java/beans/Introspector.java \
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/BeanInfoEmbryo.java kaffe/libraries/javalib/gnu/java/beans/BeanInfoEmbryo.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/BeanInfoEmbryo.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/BeanInfoEmbryo.java	2003-10-11 12:11:40.000000000 +1300
@@ -0,0 +1,165 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.BeanInfoEmbryo
+   Copyright (C) 1998, 2002 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans;
+
+import java.beans.*;
+import java.util.*;
+import gnu.java.lang.*;
+import java.lang.reflect.*;
+
+/**
+ ** A BeanInfoEmbryo accumulates information about a Bean
+ ** while it is in the process of being created, and then
+ ** when you are done accumulating the information, the
+ ** getBeanInfo() method may be called to create a BeanInfo
+ ** object based on the information.<P>
+ **
+ ** This class is not well-synchronized.  (It can be, it
+ ** just isn't yet.)
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 30 Jul 1998
+ ** @see java.beans.BeanInfo
+ **/
+
+public class BeanInfoEmbryo {
+	Hashtable properties = new Hashtable();
+	Hashtable events = new Hashtable();
+	Vector methods = new Vector();
+
+	BeanDescriptor beanDescriptor;
+	BeanInfo[] additionalBeanInfo;
+	java.awt.Image[] im;
+	String defaultPropertyName;
+	String defaultEventName;
+
+	public BeanInfoEmbryo() {
+	}
+
+	public BeanInfo getBeanInfo() {
+		int defaultProperty = -1;
+		int defaultEvent = -1;
+
+		PropertyDescriptor[] Aproperties = new PropertyDescriptor[properties.size()];
+		int i = 0;
+		Enumeration enum = properties.elements();
+		while(enum.hasMoreElements()) {
+			Aproperties[i] = (PropertyDescriptor)enum.nextElement();
+			if(defaultPropertyName != null && Aproperties[i].getName().equals(defaultPropertyName)) {
+				defaultProperty = i;
+			}
+			i++;
+		}
+
+		EventSetDescriptor[] Aevents = new EventSetDescriptor[events.size()];
+		i = 0;
+		enum = events.elements();
+		while(enum.hasMoreElements()) {
+			Aevents[i] = (EventSetDescriptor)enum.nextElement();
+			if(defaultEventName != null && Aevents[i].getName().equals(defaultEventName)) {
+				defaultEvent = i;
+			}
+			i++;
+		}
+
+		MethodDescriptor[] Amethods = new MethodDescriptor[methods.size()];
+		methods.copyInto(Amethods);
+
+		return new ExplicitBeanInfo(beanDescriptor,additionalBeanInfo,Aproperties,defaultProperty,Aevents,defaultEvent,Amethods,im);
+	}
+
+	public void setBeanDescriptor(BeanDescriptor b) {
+		beanDescriptor = b;
+	}
+
+	public void setAdditionalBeanInfo(BeanInfo[] b) {
+		additionalBeanInfo = b;
+	}
+
+	public boolean hasProperty(PropertyDescriptor p) {
+		return properties.get(p.getName()) != null;
+	}
+	public void addProperty(PropertyDescriptor p) {
+		properties.put(p.getName(),p);
+	}
+	public void addIndexedProperty(IndexedPropertyDescriptor p) {
+		properties.put(p.getName(),p);
+	}
+
+	public boolean hasEvent(EventSetDescriptor e) {
+		return events.get(e.getName()) != null;
+	}
+	public void addEvent(EventSetDescriptor e) {
+		events.put(e.getName(),e);
+	}
+
+	public boolean hasMethod(MethodDescriptor m) {
+          for(int i=0;i<methods.size();i++) {
+            Method thisMethod = ((MethodDescriptor)methods.elementAt(i)).getMethod();
+            if(m.getMethod().getName().equals(thisMethod.getName())
+               && Arrays.equals(m.getMethod().getParameterTypes(),
+                                thisMethod.getParameterTypes())) {
+              return true;
+            }
+          }
+          return false;
+	}
+	public void addMethod(MethodDescriptor m) {
+		methods.addElement(m);
+	}
+
+	public void setDefaultPropertyName(String defaultPropertyName) {
+		this.defaultPropertyName = defaultPropertyName;
+	}
+
+	public void setDefaultEventName(String defaultEventName) {
+		this.defaultEventName = defaultEventName;
+	}
+
+	public void setIcons(java.awt.Image[] im) {
+		this.im = im;
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/ExplicitBeanInfo.java kaffe/libraries/javalib/gnu/java/beans/ExplicitBeanInfo.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/ExplicitBeanInfo.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/ExplicitBeanInfo.java	2003-10-11 12:12:12.000000000 +1300
@@ -0,0 +1,151 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.ExplicitBeanInfo
+   Copyright (C) 1998 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans;
+
+import java.beans.*;
+
+/**
+ ** ExplicitBeanInfo lets you specify in the constructor
+ ** all the various parts of the BeanInfo.
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 30 Jul 1998
+ ** @see java.beans.BeanInfo
+ **/
+
+public class ExplicitBeanInfo implements BeanInfo {
+	/** The BeanDescriptor returned by getBeanDescriptor. **/
+	protected BeanDescriptor beanDescriptor;
+
+	/** The EventSetDescriptor array returned by
+	 ** getEventSetDescriptors().
+	 **/
+	protected EventSetDescriptor[] eventSetDescriptors = new EventSetDescriptor[0];
+
+	/** The PropertyDescriptor array returned by
+	 ** getPropertyDescriptors().
+	 **/
+	protected PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[0];
+
+	/** The MethodDescriptor array returned by
+	 ** getMethodDescriptors().
+	 **/
+	protected MethodDescriptor[]   methodDescriptors;
+
+	/** The default property index. **/
+	protected int defaultPropertyIndex;
+
+	/** The default event index. **/
+	protected int defaultEventIndex;
+
+	/** The BeanInfo array returned by
+	 ** getAdditionalBeanInfo().
+	 **/
+	protected BeanInfo[] additionalBeanInfo;
+
+	/** The set of icons. **/
+	protected java.awt.Image[] icons;
+
+	public ExplicitBeanInfo(BeanDescriptor beanDescriptor,
+	                        BeanInfo[] additionalBeanInfo,
+	                        PropertyDescriptor[] propertyDescriptors,
+				int defaultPropertyIndex,
+	                        EventSetDescriptor[] eventSetDescriptors,
+				int defaultEventIndex,
+	                        MethodDescriptor[] methodDescriptors,
+				java.awt.Image[] icons) {
+		this.beanDescriptor = beanDescriptor;
+		this.additionalBeanInfo = additionalBeanInfo;
+		this.propertyDescriptors = propertyDescriptors;
+		this.defaultPropertyIndex = defaultPropertyIndex;
+		this.eventSetDescriptors = eventSetDescriptors;
+		this.defaultEventIndex = defaultEventIndex;
+		this.methodDescriptors = methodDescriptors;
+		this.icons = icons;
+	}
+
+	/** Get Bean descriptor. **/
+	public BeanDescriptor getBeanDescriptor() {
+		return beanDescriptor;
+	}
+
+	/** Get Bean events. **/
+	public EventSetDescriptor[] getEventSetDescriptors() {
+		return eventSetDescriptors;
+	}
+
+	/** Get default event set. **/
+	public int getDefaultEventIndex() {
+		return defaultEventIndex;
+	}
+
+	/** Get Bean properties. **/
+	public PropertyDescriptor[] getPropertyDescriptors() {
+		return propertyDescriptors;
+	}
+
+	/** Get "default" property. **/
+	public int getDefaultPropertyIndex() {
+		return defaultPropertyIndex;
+	}
+
+	/** Get Bean methods. **/
+	public MethodDescriptor[] getMethodDescriptors() {
+		return methodDescriptors;
+	}
+
+	/** Get additional Bean info. **/
+	public BeanInfo[] getAdditionalBeanInfo() {
+		return additionalBeanInfo;
+	}
+
+	/** Get Bean icons.
+	 ** @param iconType the type of icon
+	 **/
+	public java.awt.Image getIcon(int iconType) {
+		return icons != null ? icons[iconType] : null;
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/IntrospectionIncubator.java kaffe/libraries/javalib/gnu/java/beans/IntrospectionIncubator.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/IntrospectionIncubator.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/IntrospectionIncubator.java	2003-10-11 12:12:44.000000000 +1300
@@ -0,0 +1,362 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.IntrospectionIncubator
+   Copyright (C) 1998 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans;
+
+import java.beans.*;
+import java.util.*;
+import java.lang.reflect.*;
+import gnu.java.lang.*;
+
+/**
+ ** IntrospectionIncubator takes in a bunch of Methods, and
+ ** Introspects only those Methods you give it.
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 30 Jul 1998
+ ** @see gnu.java.beans.ExplicitBeanInfo
+ ** @see java.beans.BeanInfo
+ **/
+
+public class IntrospectionIncubator {
+	Hashtable propertyMethods = new Hashtable();
+	Hashtable listenerMethods = new Hashtable();
+	Vector otherMethods = new Vector();
+
+	Class propertyStopClass;
+	Class eventStopClass;
+	Class methodStopClass;
+
+	public IntrospectionIncubator() {
+	}
+
+	/* Paving the way for automatic Introspection */
+	public void addMethod(Method method) {
+		if(Modifier.isPublic(method.getModifiers()) && !Modifier.isStatic(method.getModifiers())) {
+			String name = ClassHelper.getTruncatedName(method.getName());
+			Class retType = method.getReturnType();
+			Class[] params = method.getParameterTypes();
+			boolean isVoid = retType.equals(java.lang.Void.TYPE);
+			Class methodClass = method.getDeclaringClass();
+			if(propertyStopClass == null || (propertyStopClass.isAssignableFrom(methodClass) && !propertyStopClass.equals(methodClass))) {
+				if(name.startsWith("is")
+				   && retType.equals(java.lang.Boolean.TYPE)
+				   && params.length == 0) {
+					addToPropertyHash(name,method,IS);
+				} else if(name.startsWith("get") && !isVoid) {
+					if(params.length == 0) {
+						addToPropertyHash(name,method,GET);
+					} else if(params.length == 1 && params[0].equals(java.lang.Integer.TYPE)) {
+						addToPropertyHash(name,method,GET_I);
+					} else {
+						otherMethods.addElement(method);
+					}
+				} else if(name.startsWith("set") && isVoid) {
+					if(params.length == 1) {
+						addToPropertyHash(name,method,SET);
+					} else if(params.length == 2 && params[0].equals(java.lang.Integer.TYPE)) {
+						addToPropertyHash(name,method,SET_I);
+					} else {
+						otherMethods.addElement(method);
+					}
+				}
+			}
+			if(eventStopClass == null || (eventStopClass.isAssignableFrom(methodClass) && !eventStopClass.equals(methodClass))) {
+				if(name.startsWith("add")
+				          && isVoid
+				          && params.length == 1
+				          && java.util.EventListener.class.isAssignableFrom(params[0])) {
+					addToListenerHash(name,method,ADD);
+				} else if(name.startsWith("remove")
+				          && isVoid
+				          && params.length == 1
+				          && java.util.EventListener.class.isAssignableFrom(params[0])) {
+					addToListenerHash(name,method,REMOVE);
+				}
+			}
+			if(methodStopClass == null || (methodStopClass.isAssignableFrom(methodClass) && !methodStopClass.equals(methodClass))) {
+				otherMethods.addElement(method);
+			}
+		}
+	}
+
+	public void addMethods(Method[] m) {
+		for(int i=0;i<m.length;i++) {
+			addMethod(m[i]);
+		}
+	}
+
+	public void setPropertyStopClass(Class c) {
+		propertyStopClass = c;
+	}
+
+	public void setEventStopClass(Class c) {
+		eventStopClass = c;
+	}
+
+	public void setMethodStopClass(Class c) {
+		methodStopClass = c;
+	}
+
+
+	public BeanInfoEmbryo getBeanInfoEmbryo() throws IntrospectionException {
+		BeanInfoEmbryo b = new BeanInfoEmbryo();
+		findXXX(b,IS);
+		findXXXInt(b,GET_I);
+		findXXXInt(b,SET_I);
+		findXXX(b,GET);
+		findXXX(b,SET);
+		findAddRemovePairs(b);
+		for(int i=0;i<otherMethods.size();i++) {
+			MethodDescriptor newMethod = new MethodDescriptor((Method)otherMethods.elementAt(i));
+			if(!b.hasMethod(newMethod)) {
+				b.addMethod(new MethodDescriptor((Method)otherMethods.elementAt(i)));
+			}
+		}
+		return b;
+	}
+
+	public BeanInfo getBeanInfo() throws IntrospectionException {
+		return getBeanInfoEmbryo().getBeanInfo();
+	}
+
+
+	void findAddRemovePairs(BeanInfoEmbryo b) throws IntrospectionException {
+		Enumeration listenerEnum = listenerMethods.keys();
+		while(listenerEnum.hasMoreElements()) {
+			DoubleKey k = (DoubleKey)listenerEnum.nextElement();
+			Method[] m = (Method[])listenerMethods.get(k);
+			if(m[ADD] != null && m[REMOVE] != null) {
+				EventSetDescriptor e = new EventSetDescriptor(Introspector.decapitalize(k.getName()),
+				                                              k.getType(), k.getType().getMethods(),
+				                                              m[ADD],m[REMOVE]);
+				e.setUnicast(ArrayHelper.contains(m[ADD].getExceptionTypes(),java.util.TooManyListenersException.class));
+				if(!b.hasEvent(e)) {
+					b.addEvent(e);
+				}
+			}
+		}
+	}
+
+	void findXXX(BeanInfoEmbryo b, int funcType) throws IntrospectionException {
+		Enumeration keys = propertyMethods.keys();
+		while(keys.hasMoreElements()) {
+			DoubleKey k = (DoubleKey)keys.nextElement();
+			Method[] m = (Method[])propertyMethods.get(k);
+			if(m[funcType] != null) {
+				PropertyDescriptor p = new PropertyDescriptor(Introspector.decapitalize(k.getName()),
+				                                     m[IS] != null ? m[IS] : m[GET],
+				                                     m[SET]);
+				if(m[SET] != null) {
+					p.setConstrained(ArrayHelper.contains(m[SET].getExceptionTypes(),java.beans.PropertyVetoException.class));
+				}
+				if(!b.hasProperty(p)) {
+					b.addProperty(p);
+				}
+			}
+		}
+	}
+
+	void findXXXInt(BeanInfoEmbryo b, int funcType) throws IntrospectionException {
+		Enumeration keys = propertyMethods.keys();
+		while(keys.hasMoreElements()) {
+			DoubleKey k = (DoubleKey)keys.nextElement();
+			Method[] m = (Method[])propertyMethods.get(k);
+			if(m[funcType] != null) {
+				boolean constrained;
+				if(m[SET_I] != null) {
+					constrained = ArrayHelper.contains(m[SET_I].getExceptionTypes(),java.beans.PropertyVetoException.class);
+				} else {
+					constrained = false;
+				}
+
+				/** Find out if there is an array type get or set **/
+				Class arrayType = Array.newInstance(k.getType(),0).getClass();
+				DoubleKey findSetArray = new DoubleKey(arrayType,k.getName());
+				Method[] m2 = (Method[])propertyMethods.get(findSetArray);
+				IndexedPropertyDescriptor p;
+				if(m2 == null) {
+					p = new IndexedPropertyDescriptor(Introspector.decapitalize(k.getName()),
+				                                          null,null,
+				                                          m[GET_I],m[SET_I]);
+				} else {
+					if(constrained && m2[SET] != null) {
+						constrained = ArrayHelper.contains(m2[SET].getExceptionTypes(),java.beans.PropertyVetoException.class);
+					}
+					p = new IndexedPropertyDescriptor(Introspector.decapitalize(k.getName()),
+				                                          m2[GET],m2[SET],
+				                                          m[GET_I],m[SET_I]);
+				}
+				p.setConstrained(constrained);
+				if(!b.hasProperty(p)) {
+					b.addProperty(p);
+				}
+			}
+		}
+	}
+
+	static final int IS=0;
+	static final int GET_I=1;
+	static final int SET_I=2;
+	static final int GET=3;
+	static final int SET=4;
+
+	static final int ADD=0;
+	static final int REMOVE=1;
+
+	void addToPropertyHash(String name, Method method, int funcType) {
+		String newName;
+		Class type;
+
+		switch(funcType) {
+			case IS:
+				type = java.lang.Boolean.TYPE;
+				newName = name.substring(2);
+				break;
+			case GET_I:
+				type = method.getReturnType();
+				newName = name.substring(3);
+				break;
+			case SET_I:
+				type = method.getParameterTypes()[1];
+				newName = name.substring(3);
+				break;
+			case GET:
+				type = method.getReturnType();
+				newName = name.substring(3);
+				break;
+			case SET:
+				type = method.getParameterTypes()[0];
+				newName = name.substring(3);
+				break;
+			default:
+				return;
+		}
+		newName = capitalize(newName);
+
+		DoubleKey k = new DoubleKey(type,newName);
+		Method[] methods = (Method[])propertyMethods.get(k);
+		if(methods == null) {
+			methods = new Method[5];
+			propertyMethods.put(k,methods);
+		}
+		methods[funcType] = method;
+	}
+
+
+	void addToListenerHash(String name, Method method, int funcType) {
+		String newName;
+		Class type;
+
+		switch(funcType) {
+			case ADD:
+				type = method.getParameterTypes()[0];
+				newName = name.substring(3,name.length()-8);
+				break;
+			case REMOVE:
+				type = method.getParameterTypes()[0];
+				newName = name.substring(6,name.length()-8);
+				break;
+			default:
+				return;
+		}
+		newName = capitalize(newName);
+
+		DoubleKey k = new DoubleKey(type,newName);
+		Method[] methods = (Method[])listenerMethods.get(k);
+		if(methods == null) {
+			methods = new Method[2];
+			listenerMethods.put(k,methods);
+		}
+		methods[funcType] = method;
+	}
+
+	static String capitalize(String name) {
+		try {
+			if(Character.isUpperCase(name.charAt(0))) {
+				return name;
+			} else {
+				char[] c = name.toCharArray();
+				c[0] = Character.toLowerCase(c[0]);
+				return new String(c);
+			}
+		} catch(StringIndexOutOfBoundsException E) {
+			return name;
+		} catch(NullPointerException E) {
+			return null;
+		}
+	}
+}
+
+class DoubleKey {
+	Class type;
+	String name;
+
+	DoubleKey(Class type, String name) {
+		this.type = type;
+		this.name = name;
+	}
+
+	Class getType() {
+		return type;
+	}
+
+	String getName() {
+		return name;
+	}
+
+	public boolean equals(Object o) {
+		if(o instanceof DoubleKey) {
+			DoubleKey d = (DoubleKey)o;
+			return d.type.equals(type) && d.name.equals(name);
+		} else {
+			return false;
+		}
+	}
+
+	public int hashCode() {
+		return type.hashCode() ^ name.hashCode();
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/editors/ColorEditor.java kaffe/libraries/javalib/gnu/java/beans/editors/ColorEditor.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/editors/ColorEditor.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/editors/ColorEditor.java	2003-10-11 12:15:37.000000000 +1300
@@ -0,0 +1,107 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.editors.ColorEditor
+   Copyright (C) 1998 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans.editors;
+
+import java.beans.*;
+import java.awt.Color;
+
+/**
+ ** NativeByteEditor is a property editor for the
+ ** byte type.
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 29 Jul 1998
+ **/
+
+public class ColorEditor extends PropertyEditorSupport {
+	Color[] stdColors = {Color.black,Color.blue,Color.cyan,
+	                     Color.darkGray,Color.gray,Color.green,
+	                     Color.lightGray,Color.magenta,Color.orange,
+	                     Color.pink,Color.red,Color.white,
+	                     Color.yellow};
+	String[] stdColorNames = {"black","blue","cyan",
+	                          "dark gray","gray","green",
+	                          "light gray","magenta","orange",
+	                          "pink","red","white",
+	                          "yellow"};
+
+	/** setAsText for Color checks for standard color names
+	 ** and then checks for a #RRGGBB value or just RRGGBB,
+	 ** both in hex.
+	 **/
+	public void setAsText(String val) throws IllegalArgumentException {
+		if(val.length() == 0) {
+			throw new IllegalArgumentException("Tried to set empty value!");
+		}
+		for(int i=0;i<stdColorNames.length;i++) {
+			if(stdColorNames[i].equalsIgnoreCase(val)) {
+				setValue(stdColors[i]);
+				return;
+			}
+		}
+		if(val.charAt(0) == '#') {
+			setValue(new Color(Integer.parseInt(val.substring(1),16)));
+		} else {
+			setValue(new Color(Integer.parseInt(val,16)));
+		}
+	}
+
+	/** getAsText for Color turns the color into either one of the standard
+	 ** colors or into an RGB hex value with # prepended. **/
+	public String getAsText() {
+		for(int i=0;i<stdColors.length;i++) {
+			if(stdColors[i].equals(getValue())) {
+				return stdColorNames[i];
+			}
+		}
+		return "#" + Integer.toHexString(((Color)getValue()).getRGB() & 0x00FFFFFF);
+	}
+
+	/** getTags for Color returns a list of standard colors. **/
+	public String[] getTags() {
+		return stdColorNames;
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/editors/FontEditor.java kaffe/libraries/javalib/gnu/java/beans/editors/FontEditor.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/editors/FontEditor.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/editors/FontEditor.java	2003-10-11 12:15:52.000000000 +1300
@@ -0,0 +1,84 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.editors.FontEditor
+   Copyright (C) 1998 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans.editors;
+
+import java.beans.*;
+import java.awt.Font;
+
+/**
+ ** FontEditor is a property editor for java.awt.Font.
+ **
+ ** <STRONG>To Do:</STRONG> Add custom font chooser
+ ** component.
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 29 Jul 1998
+ **/
+
+public class FontEditor extends PropertyEditorSupport {
+	/** setAsText for Font calls Font.decode(). **/
+	public void setAsText(String val) throws IllegalArgumentException {
+		setValue(Font.decode(val));
+	}
+
+	/** getAsText for Font returns a value in the format
+	 ** expected by Font.decode().
+	 **/
+	public String getAsText() {
+		Font f = (Font)getValue();
+		if(f.isBold()) {
+			if(f.isItalic()) {
+				return f.getName()+"-bolditalic-"+f.getSize();
+			} else {
+				return f.getName()+"-bold-"+f.getSize();
+			}
+		} else if(f.isItalic()) {
+			return f.getName()+"-italic-"+f.getSize();
+		} else {
+			return f.getName()+"-"+f.getSize();
+		}
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeBooleanEditor.java kaffe/libraries/javalib/gnu/java/beans/editors/NativeBooleanEditor.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeBooleanEditor.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/editors/NativeBooleanEditor.java	2003-10-11 12:16:08.000000000 +1300
@@ -0,0 +1,83 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.editors.NativeBooleanEditor
+   Copyright (C) 1998, 2002 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans.editors;
+
+import java.beans.*;
+
+/**
+ ** NativeBooleanEditor is a property editor for the
+ ** boolean type.<P>
+ **
+ ** <STRONG>To Do:</STRONG> add support for a checkbox
+ ** as the custom editor.
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 29 Jul 1998
+ **/
+
+public class NativeBooleanEditor extends PropertyEditorSupport {
+	String[] tags = {"true","false"};
+
+	/**
+	 * setAsText for boolean checks for true or false or t or f.
+	 * "" also means false.
+	 **/
+	public void setAsText(String val) throws IllegalArgumentException {
+		if(val.equalsIgnoreCase("true") || val.equalsIgnoreCase("t")) {
+			setValue(Boolean.TRUE);
+		} else if(val.equalsIgnoreCase("false") || val.equalsIgnoreCase("f") || val.equals("")) {
+			setValue(Boolean.FALSE);
+		} else {
+			throw new IllegalArgumentException("Value must be true, false, t, f or empty.");
+		}
+	}
+
+
+	/** getAsText for boolean calls Boolean.toString(). **/
+	public String getAsText() {
+		return getValue().toString();
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeByteEditor.java kaffe/libraries/javalib/gnu/java/beans/editors/NativeByteEditor.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeByteEditor.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/editors/NativeByteEditor.java	2003-10-11 12:16:30.000000000 +1300
@@ -0,0 +1,68 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.editors.NativeByteEditor
+   Copyright (C) 1998 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans.editors;
+
+import java.beans.*;
+
+/**
+ ** NativeByteEditor is a property editor for the
+ ** byte type.
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 29 Jul 1998
+ **/
+
+public class NativeByteEditor extends PropertyEditorSupport {
+	/** setAsText for byte calls Byte.valueOf(). **/
+	public void setAsText(String val) throws IllegalArgumentException {
+		setValue(Byte.valueOf(val));
+	}
+
+	/** getAsText for byte calls Byte.toString(). **/
+	public String getAsText() {
+		return getValue().toString();
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeDoubleEditor.java kaffe/libraries/javalib/gnu/java/beans/editors/NativeDoubleEditor.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeDoubleEditor.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/editors/NativeDoubleEditor.java	2003-10-11 12:16:49.000000000 +1300
@@ -0,0 +1,68 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.editors.NativeDoubleEditor
+   Copyright (C) 1998 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans.editors;
+
+import java.beans.*;
+
+/**
+ ** NativeDoubleEditor is a property editor for the
+ ** double type.
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 29 Jul 1998
+ **/
+
+public class NativeDoubleEditor extends PropertyEditorSupport {
+	/** setAsText for double calls Double.valueOf(). **/
+	public void setAsText(String val) throws IllegalArgumentException {
+		setValue(Double.valueOf(val));
+	}
+
+	/** getAsText for double calls Double.toString(). **/
+	public String getAsText() {
+		return getValue().toString();
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeFloatEditor.java kaffe/libraries/javalib/gnu/java/beans/editors/NativeFloatEditor.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeFloatEditor.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/editors/NativeFloatEditor.java	2003-10-11 12:17:06.000000000 +1300
@@ -0,0 +1,68 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.editors.NativeFloatEditor
+   Copyright (C) 1998 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans.editors;
+
+import java.beans.*;
+
+/**
+ ** NativeFloatEditor is a property editor for the
+ ** float type.
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 29 Jul 1998
+ **/
+
+public class NativeFloatEditor extends PropertyEditorSupport {
+	/** setAsText for float calls Float.valueOf(). **/
+	public void setAsText(String val) throws IllegalArgumentException {
+		setValue(Float.valueOf(val));
+	}
+
+	/** getAsText for float calls Float.toString(). **/
+	public String getAsText() {
+		return getValue().toString();
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeIntEditor.java kaffe/libraries/javalib/gnu/java/beans/editors/NativeIntEditor.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeIntEditor.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/editors/NativeIntEditor.java	2003-10-11 12:17:20.000000000 +1300
@@ -0,0 +1,68 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.editors.NativeIntEditor
+   Copyright (C) 1998 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans.editors;
+
+import java.beans.*;
+
+/**
+ ** NativeIntEditor is a property editor for the
+ ** int type.
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 29 Jul 1998
+ **/
+
+public class NativeIntEditor extends PropertyEditorSupport {
+	/** setAsText for int calls Integer.valueOf(). **/
+	public void setAsText(String val) throws IllegalArgumentException {
+		setValue(Integer.valueOf(val));
+	}
+
+	/** getAsText for int calls Integer.toString(). **/
+	public String getAsText() {
+		return getValue().toString();
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeLongEditor.java kaffe/libraries/javalib/gnu/java/beans/editors/NativeLongEditor.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeLongEditor.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/editors/NativeLongEditor.java	2003-10-11 12:17:44.000000000 +1300
@@ -0,0 +1,68 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.editors.NativeLongEditor
+   Copyright (C) 1998 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans.editors;
+
+import java.beans.*;
+
+/**
+ ** NativeLongEditor is a property editor for the
+ ** long type.
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 29 Jul 1998
+ **/
+
+public class NativeLongEditor extends PropertyEditorSupport {
+	/** setAsText for long calls Long.valueOf(). **/
+	public void setAsText(String val) throws IllegalArgumentException {
+		setValue(Long.valueOf(val));
+	}
+
+	/** getAsText for long calls Long.toString(). **/
+	public String getAsText() {
+		return getValue().toString();
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeShortEditor.java kaffe/libraries/javalib/gnu/java/beans/editors/NativeShortEditor.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/editors/NativeShortEditor.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/editors/NativeShortEditor.java	2003-10-11 12:18:22.000000000 +1300
@@ -0,0 +1,68 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.editors.NativeShortEditor
+   Copyright (C) 1998 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans.editors;
+
+import java.beans.*;
+
+/**
+ ** NativeShortEditor is a property editor for the
+ ** short type.
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 29 Jul 1998
+ **/
+
+public class NativeShortEditor extends PropertyEditorSupport {
+	/** setAsText for short calls Short.valueOf(). **/
+	public void setAsText(String val) throws IllegalArgumentException {
+		setValue(Short.valueOf(val));
+	}
+
+	/** getAsText for short calls Short.toString(). **/
+	public String getAsText() {
+		return getValue().toString();
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/beans/editors/StringEditor.java kaffe/libraries/javalib/gnu/java/beans/editors/StringEditor.java
--- kaffe_orig/libraries/javalib/gnu/java/beans/editors/StringEditor.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/beans/editors/StringEditor.java	2003-10-11 12:18:41.000000000 +1300
@@ -0,0 +1,68 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* gnu.java.beans.editors.StringEditor
+   Copyright (C) 1998 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.beans.editors;
+
+import java.beans.*;
+
+/**
+ ** NativeByteEditor is a property editor for the
+ ** byte type.
+ **
+ ** @author John Keiser
+ ** @version 1.1.0, 29 Jul 1998
+ **/
+
+public class StringEditor extends PropertyEditorSupport {
+	/** setAsText just sets the value. **/
+	public void setAsText(String val) throws IllegalArgumentException {
+		setValue(val);
+	}
+
+	/** getAsText just returns the value. **/
+	public String getAsText() {
+		return (String)getValue();
+	}
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/gnu/java/lang/ArrayHelper.java kaffe/libraries/javalib/gnu/java/lang/ArrayHelper.java
--- kaffe_orig/libraries/javalib/gnu/java/lang/ArrayHelper.java	1970-01-01 12:00:00.000000000 +1200
+++ kaffe/libraries/javalib/gnu/java/lang/ArrayHelper.java	2003-10-11 12:19:49.000000000 +1300
@@ -0,0 +1,85 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* ArrayHelper.java -- Helper methods for handling array operations
+   Copyright (C) 1998, 2002 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package gnu.java.lang;
+
+/**
+ * ArrayHelper helps you do things with arrays.
+ *
+ * @author John Keiser
+ */
+public class ArrayHelper
+{
+  /**
+   * Counterpart to java.util.Collection.contains.
+   *
+   * @param array the array to search
+   * @param searchFor the object to locate
+   * @return true if some array element <code>equals(searchFor)</code>
+   */
+  public static boolean contains(Object[] array, Object searchFor)
+  {
+    return indexOf(array, searchFor) != -1;
+  }
+
+  /**
+   * Counterpart to java.util.Collection.indexOf.
+   *
+   * @param array the array to search
+   * @param searchFor the object to locate
+   * @return the index of the first equal object, or -1
+   */
+  public static int indexOf(Object[] array, Object searchFor)
+  {
+    for (int i = 0; i < array.length; i++)
+      {
+        if(array[i].equals(searchFor))
+          {
+            return i;
+          }
+      }
+    return -1;
+  }
+}
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/beans/IndexedPropertyDescriptor.java kaffe/libraries/javalib/java/beans/IndexedPropertyDescriptor.java
--- kaffe_orig/libraries/javalib/java/beans/IndexedPropertyDescriptor.java	2003-09-26 14:19:21.000000000 +1200
+++ kaffe/libraries/javalib/java/beans/IndexedPropertyDescriptor.java	2003-10-11 14:35:51.000000000 +1300
@@ -1,152 +1,314 @@
-package java.beans;
-
-import java.lang.reflect.Method;
-
 /*
- * Java core library component.
  *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ * Imported from GNU Classpath by M.Negovanovic
  *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
- *
- * FIXME: Fix constructors to implement initialization according to
- * Java Class Libraries 2nd Ed. Vol. 2.
  */
-public class IndexedPropertyDescriptor
-  extends PropertyDescriptor
-{
-	private Method idxgetter;
-	private Method idxsetter;
-	private Class idxrettype;
-
-public IndexedPropertyDescriptor(String propertyName, Class beanClass) throws IntrospectionException
-{
-	super(propertyName, beanClass);
 
-	init(beanClass);
-	check();
-}
 
-public IndexedPropertyDescriptor(String propertyName, Class beanClass, String getterName, String setterName, String indexedGetterName, String indexedSetterName) throws IntrospectionException
-{
-	super(propertyName, beanClass, getterName, setterName);
+/* java.beans.IndexedPropertyDescriptor
+   Copyright (C) 1998 Free Software Foundation, Inc.
 
-	init(beanClass, indexedGetterName, indexedSetterName);
-	check();
-}
+This file is part of GNU Classpath.
 
-public IndexedPropertyDescriptor(String propertyName, Method getter, Method setter, Method indexedGetter, Method indexedSetter) throws IntrospectionException
-{
-	super(propertyName, getter, setter);
-	idxgetter = indexedGetter;
-	idxsetter = indexedSetter;
-	if (idxgetter != null) {
-		idxrettype = idxgetter.getReturnType();
-	}
-	else if (idxsetter != null) {
-		idxrettype = idxsetter.getParameterTypes()[1];
-	}
-	check();
-}
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
-private void check() throws IntrospectionException {
-	checkGetter(getIndexedReadMethod());
-	checkSetter(getIndexedWriteMethod());
-	checkGetterAndSetterMatch(getIndexedReadMethod(), getIndexedWriteMethod());
-}
 
-private void checkGetterAndSetterMatch(Method getter, Method setter) throws IntrospectionException {
-	Class rettype = getIndexedPropertyType();
-	if ((getter != null
-	     && getter.getReturnType() != rettype)
-	    || (setter != null
-		&& setter.getParameterTypes()[1] != rettype)) {
-		throw new IntrospectionException("Getter method "
-						 + getter
-						 + " and setter method "
-						 + setter
-						 + " don't match.");
-	}
-}
+package java.beans;
 
-private void checkSetter(Method method) throws IntrospectionException {
-	if (method != null) {
-		if (method.getParameterTypes().length != 2) {
-			throw new IntrospectionException("Setter method "
-							 + method
-							 + " must accept only two pararmeters.");
-		}
-		else if (method.getReturnType() != Void.TYPE) {
-			throw new IntrospectionException("Setter method "
-							 + method
-							 + " must return void.");
-		}
-	}
-}
+import java.util.*;
+import java.lang.reflect.*;
 
-private void checkGetter(Method method) throws IntrospectionException {
-	if (method != null) {
-		if (method.getParameterTypes().length != 1) {
-			throw new IntrospectionException("Getter method "
-							 + method
-							 + " must accept only one pararmeter.");
-		}
-		else if (method.getReturnType() == Void.TYPE) {
-			throw new IntrospectionException("Getter method "
-							 + method
-							 + " must not return void.");
+/**
+ ** IndexedPropertyDescriptor describes information about a JavaBean
+ ** indexed property, by which we mean an array-like property that
+ ** has been exposed via a pair of get and set methods and another
+ ** pair that allows you to get to the property by an index.<P>
+ **
+ ** An example property would have four methods like this:<P>
+ ** <CODE>FooBar[] getFoo()</CODE><BR>
+ ** <CODE>void setFoo(FooBar[])</CODE><BR>
+ ** <CODE>FooBar getFoo(int)</CODE><BR>
+ ** <CODE>void setFoo(int,FooBar)</CODE><P>
+ **
+ ** The constraints put on get and set methods are:<P>
+ ** <OL>
+ ** <LI>There must be at least a get(int) or a set(int,...) method.
+ ** Nothing else is required.  <B>Spec note:</B>One nice restriction
+ ** would be that if there is a get() there must be a get(int), same
+ ** with set, but that is not in the spec and is fairly harmless.)</LI>
+ ** <LI>A get array method must have signature
+ **     <CODE>&lt;propertyType&gt;[] &lt;getMethodName&gt;()</CODE></LI>
+ ** <LI>A set array method must have signature
+ **     <CODE>void &lt;setMethodName&gt;(&lt;propertyType&gt;[])</CODE></LI>
+ ** <LI>A get index method must have signature
+ **     <CODE>&lt;propertyType&gt; &lt;getMethodName&gt;(int)</CODE></LI>
+ ** <LI>A set index method must have signature
+ **     <CODE>void &lt;setMethodName&gt;(int,&lt;propertyType&gt;)</CODE></LI>
+ ** <LI>All these methods may throw any exception.</LI>
+ ** <LI>All these methods must be public.</LI>
+ ** </OL>
+ **
+ ** @author John Keiser
+ ** @since JDK1.1
+ ** @version 1.1.0, 26 Jul 1998
+ **/
+
+public class IndexedPropertyDescriptor extends PropertyDescriptor {
+	private Class indexedPropertyType;
+	private Method setIndex;
+	private Method getIndex;
+
+	/** Create a new IndexedPropertyDescriptor by introspection.
+	 ** This form of constructor creates the PropertyDescriptor by
+	 ** looking for getter methods named <CODE>get&lt;name&gt;()</CODE>
+	 ** and setter methods named
+	 ** <CODE>set&lt;name&gt;()</CODE> in class
+	 ** <CODE>&lt;beanClass&gt;</CODE>, where &lt;name&gt; has its
+	 ** first letter capitalized by the constructor.<P>
+	 **
+	 ** <B>Implementation note:</B> If there is a get(int) method,
+	 ** then the return type of that method is used to find the
+	 ** remaining methods.  If there is no get method, then the
+	 ** set(int) method is searched for exhaustively and that type
+	 ** is used to find the others.<P>
+	 **
+	 ** <B>Spec note:</B>
+	 ** If there is no get(int) method and multiple set(int) methods with
+	 ** the same name and the correct parameters (different type of course),
+	 ** then an IntrospectionException is thrown.  While Sun's spec
+	 ** does not state this, it can make Bean behavior different on
+	 ** different systems (since method order is not guaranteed) and as
+	 ** such, can be treated as a bug in the spec.  I am not aware of
+	 ** whether Sun's implementation catches this.
+	 **
+	 ** @param name the programmatic name of the property, usually
+	 **             starting with a lowercase letter (e.g. fooManChu
+	 **             instead of FooManChu).
+	 ** @param beanClass the class the get and set methods live in.
+	 ** @exception IntrospectionException if the methods are not found or invalid.
+	 **/
+	public IndexedPropertyDescriptor(String name, Class beanClass) throws IntrospectionException {
+		super(name);
+		String capitalized;
+		try {
+			capitalized = Character.toUpperCase(name.charAt(0)) + name.substring(1);
+		} catch(StringIndexOutOfBoundsException e) {
+			capitalized = "";
 		}
+		findMethods(beanClass, "get" + capitalized, "set" + capitalized, "get" + capitalized, "set" + capitalized);
 	}
-}
-
-public Class getIndexedPropertyType()
-	{
-	return (idxrettype);
-}
 
-public Method getIndexedReadMethod()
-	{
-	return (idxgetter);
-}
+	/** Create a new IndexedPropertyDescriptor by introspection.
+	 ** This form of constructor allows you to specify the
+	 ** names of the get and set methods to search for.<P>
+	 **
+	 ** <B>Implementation note:</B> If there is a get(int) method,
+	 ** then the return type of that method is used to find the
+	 ** remaining methods.  If there is no get method, then the
+	 ** set(int) method is searched for exhaustively and that type
+	 ** is used to find the others.<P>
+	 **
+	 ** <B>Spec note:</B>
+	 ** If there is no get(int) method and multiple set(int) methods with
+	 ** the same name and the correct parameters (different type of course),
+	 ** then an IntrospectionException is thrown.  While Sun's spec
+	 ** does not state this, it can make Bean behavior different on
+	 ** different systems (since method order is not guaranteed) and as
+	 ** such, can be treated as a bug in the spec.  I am not aware of
+	 ** whether Sun's implementation catches this.
+	 **
+	 ** @param name the programmatic name of the property, usually
+	 **             starting with a lowercase letter (e.g. fooManChu
+	 **             instead of FooManChu).
+	 ** @param beanClass the class the get and set methods live in.
+	 ** @param getMethodName the name of the get array method.
+	 ** @param setMethodName the name of the set array method.
+	 ** @param getIndexName the name of the get index method.
+	 ** @param setIndexName the name of the set index method.
+	 ** @exception IntrospectionException if the methods are not found or invalid.
+	 **/
+	public IndexedPropertyDescriptor(String name, Class beanClass, String getMethodName, String setMethodName, String getIndexName, String setIndexName) throws IntrospectionException {
+		super(name);
+		findMethods(beanClass, getMethodName, setMethodName, getIndexName, setIndexName);
+	}
 
-public Method getIndexedWriteMethod()
-	{
-	return (idxsetter);
-}
+	/** Create a new PropertyDescriptor using explicit Methods.
+	 ** Note that the methods will be checked for conformance to standard
+	 ** Property method rules, as described above at the top of this class.
+	 ** 
+	 ** @param name the programmatic name of the property, usually
+	 **             starting with a lowercase letter (e.g. fooManChu
+	 **             instead of FooManChu).
+	 ** @param getMethod the get array method.
+	 ** @param setMethod the set array method.
+	 ** @param getIndex the get index method.
+	 ** @param setIndex the set index method.
+	 ** @exception IntrospectionException if the methods are not found or invalid.
+	 **/
+	public IndexedPropertyDescriptor(String name, Method getMethod, Method setMethod, Method getIndex, Method setIndex) throws IntrospectionException {
+		super(name);
+		if(getMethod != null && getMethod.getParameterTypes().length > 0) {
+			throw new IntrospectionException("get method has parameters");
+		}
+		if(getMethod != null && setMethod.getParameterTypes().length != 1) {
+			throw new IntrospectionException("set method does not have exactly one parameter");
+		}
+		if(getMethod != null && setMethod != null) {
+			if(!getMethod.getReturnType().equals(setMethod.getParameterTypes()[0])) {
+				throw new IntrospectionException("set and get methods do not share the same type");
+			}
+			if(!getMethod.getDeclaringClass().isAssignableFrom(setMethod.getDeclaringClass())
+			   && !setMethod.getDeclaringClass().isAssignableFrom(getMethod.getDeclaringClass())) {
+				throw new IntrospectionException("set and get methods are not in the same class.");
+			}
+		}
 
-private void init(Class beanClass) throws IntrospectionException {
-	init(beanClass, getReadMethod().getName(), getWriteMethod().getName());
-}
+		if(getIndex != null && (getIndex.getParameterTypes().length != 1
+		   || !(getIndex.getParameterTypes()[0]).equals(java.lang.Integer.TYPE))) {
+			throw new IntrospectionException("get index method has wrong parameters");
+		}
+		if(setIndex != null && (setIndex.getParameterTypes().length != 2
+		   || !(setIndex.getParameterTypes()[0]).equals(java.lang.Integer.TYPE))) {
+			throw new IntrospectionException("set index method has wrong parameters");
+		}
+		if(getIndex != null && setIndex != null) {
+			if(!getIndex.getReturnType().equals(setIndex.getParameterTypes()[1])) {
+				throw new IntrospectionException("set index methods do not share the same type");
+			}
+			if(!getIndex.getDeclaringClass().isAssignableFrom(setIndex.getDeclaringClass())
+			   && !setIndex.getDeclaringClass().isAssignableFrom(getIndex.getDeclaringClass())) {
+				throw new IntrospectionException("get and set index methods are not in the same class.");
+			}
+		}
 
-private void init(Class beanClass, String indexedGetterName, String indexedSetterName) throws IntrospectionException {
-	NoSuchMethodException ex = null;
+		if(getIndex != null && getMethod != null && !getIndex.getDeclaringClass().isAssignableFrom(getMethod.getDeclaringClass())
+		   && !getMethod.getDeclaringClass().isAssignableFrom(getIndex.getDeclaringClass())) {
+			throw new IntrospectionException("methods are not in the same class.");
+		}
 
-	try {
-		Class[] getParam = new Class[1];
-		getParam[0] = Integer.TYPE;
+		if(getIndex != null && getMethod != null && !Array.newInstance(getIndex.getReturnType(),0).getClass().equals(getMethod.getReturnType())) {
+			throw new IntrospectionException("array methods do not match index methods.");
+		}
 
-		idxgetter = beanClass.getMethod(indexedGetterName, getParam);
-		idxrettype = idxgetter.getReturnType();
-	}
-	catch (NoSuchMethodException nsme) {
-		ex = nsme;
+		this.getMethod = getMethod;
+		this.setMethod = setMethod;
+		this.getIndex = getIndex;
+		this.setIndex = setIndex;
+		this.indexedPropertyType = getIndex != null ? getIndex.getReturnType() : setIndex.getParameterTypes()[1];
+		this.propertyType = getMethod != null ? getMethod.getReturnType() : (setMethod != null ? setMethod.getParameterTypes()[0] : Array.newInstance(this.indexedPropertyType,0).getClass());
 	}
-	try {
-		Class[] setParam = new Class[2];
-		setParam[0] = Integer.TYPE;
-		setParam[1] = idxrettype;
 
-		idxsetter = beanClass.getMethod(indexedSetterName, setParam);
+	public Class getIndexedPropertyType() {
+		return indexedPropertyType;
 	}
-	catch (NoSuchMethodException nsme) {
-		ex = nsme;
+
+	public Method getIndexedReadMethod() {
+		return getIndex;
 	}
 
-	if (ex != null) {
-		throw new IntrospectionException("failed");
+	public Method getIndexedWriteMethod() {
+		return setIndex;
 	}
-}
 
+	private void findMethods(Class beanClass, String getMethodName, String setMethodName, String getIndexName, String setIndexName) throws IntrospectionException {
+		try {
+			if(getIndexName != null) {
+				try {
+					Class[] getArgs = new Class[1];
+					getArgs[0] = java.lang.Integer.TYPE;
+					getIndex = beanClass.getMethod(getIndexName,getArgs);
+					indexedPropertyType = getIndex.getReturnType();
+				} catch(NoSuchMethodException E) {
+				}
+			}
+			if(getIndex != null) {
+				if(setIndexName != null) {
+					try {
+						Class[] setArgs = new Class[2];
+						setArgs[0] = java.lang.Integer.TYPE;
+						setArgs[1] = indexedPropertyType;
+						setIndex = beanClass.getMethod(setIndexName,setArgs);
+						if(!setIndex.getReturnType().equals(java.lang.Void.TYPE)) {
+							throw new IntrospectionException(setIndexName + " has non-void return type");
+						}
+					} catch(NoSuchMethodException E) {
+					}
+				}
+			} else if(setIndexName != null) {
+				Method[] m = beanClass.getMethods();
+				for(int i=0;i<m.length;i++) {
+					Method current = m[i];
+					if(current.getName().equals(setIndexName)
+					   && current.getParameterTypes().length == 2
+					   && (current.getParameterTypes()[0]).equals(java.lang.Integer.TYPE)
+					   && current.getReturnType().equals(java.lang.Void.TYPE)) {
+						if(setIndex != null) {
+							throw new IntrospectionException("Multiple, different set methods found that fit the bill!");
+						} else {
+							setIndex = current;
+							indexedPropertyType = current.getParameterTypes()[1];
+						}
+					}
+				}
+				if(setIndex == null) {
+					throw new IntrospectionException("Cannot find get or set methods.");
+				}
+			} else {
+				throw new IntrospectionException("Cannot find get or set methods.");
+			}
+
+			Class arrayType = Array.newInstance(indexedPropertyType,0).getClass();
+
+			Class[] setArgs = new Class[1];
+			setArgs[0] = arrayType;
+			try {
+				setMethod = beanClass.getMethod(setMethodName,setArgs);
+				if(!setMethod.getReturnType().equals(java.lang.Void.TYPE)) {
+					setMethod = null;
+				}
+			} catch(NoSuchMethodException E) {
+			}
+
+			Class[] getArgs = new Class[0];
+			try {
+				getMethod = beanClass.getMethod(getMethodName,getArgs);
+				if(!getMethod.getReturnType().equals(arrayType)) {
+					getMethod = null;
+				}
+			} catch(NoSuchMethodException E) {
+			}
+		} catch(SecurityException E) {
+			throw new IntrospectionException("SecurityException while trying to find methods.");
+		}
+	}
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/beans/Introspector.java kaffe/libraries/javalib/java/beans/Introspector.java
--- kaffe_orig/libraries/javalib/java/beans/Introspector.java	2003-09-26 14:19:21.000000000 +1200
+++ kaffe/libraries/javalib/java/beans/Introspector.java	2003-10-11 14:36:32.000000000 +1300
@@ -1,398 +1,564 @@
-package java.beans;
-
-import java.lang.reflect.Method;
-import java.lang.reflect.Modifier;
-import java.util.Enumeration;
-import java.util.Hashtable;
-import java.util.TooManyListenersException;
-
 /*
- * Java core library component.
  *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ * Imported from GNU Classpath by M.Negovanovic
  *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
  */
-public class Introspector {
 
-public static final int USE_ALL_BEANINFO = 1;
-public static final int IGNORE_IMMEDIATE_BEANINFO = 2;
-public static final int IGNORE_ALL_BEANINFO = 3;
-
-private static String[] beansearch = { "kaffe.beans.infos" };
-
-private static Hashtable cache = new Hashtable();
-
-private static final String ADD = "add";
-private static final String GET = "get";
-private static final String IS = "is";
-private static final String LISTENER = "Listener";
-private static final String REMOVE = "remove";
-private static final String SET = "set";
-private static final int ADD_LENGTH = ADD.length();
-private static final int GET_LENGTH = GET.length();
-private static final int IS_LENGTH = IS.length();
-private static final int LISTENER_LENGTH = LISTENER.length();
-private static final int REMOVE_LENGTH = REMOVE.length();
-private static final int SET_LENGTH = SET.length();
 
-private static final String BEAN_INFO = "BeanInfo";
-private static final String ADD_PROPERTY_CHANGE_LISTENER = ADD + "PropertyChange" + LISTENER;
+/* java.beans.Introspector
+   Copyright (C) 1998, 2002 Free Software Foundation, Inc.
 
-private Introspector() {}
-    
-public static String decapitalize(String name) {
-	if (name.length() > 2 && Character.isUpperCase(name.charAt(0)) && Character.isUpperCase(name.charAt(1))) {
-		return (name);
-	}
-	else if (name.length() > 0) {        /* empty string */
-		return (Character.toLowerCase(name.charAt(0)) + name.substring(1));
-	}
-	else {
-		return (name);
-	}
-}
-
-public static BeanInfo getBeanInfo(Class beanClass) throws IntrospectionException {
-	return (getBeanInfo(beanClass, null));
-}
-
-public static BeanInfo getBeanInfo(Class beanClass, Class stopClass) throws IntrospectionException {
+This file is part of GNU Classpath.
 
-	Object cobj = cache.get(beanClass);
-	if (cobj != null) {
-		return ((BeanInfo)cobj);
-	}
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
-	BeanInfo bean = loadBeanInfo(beanClass);
 
-	// Check stop class is really a superclass of bean class
-	if (stopClass != null
-	    && (!stopClass.isAssignableFrom(beanClass)
-	      || beanClass.isInterface())) {
-		throw new IntrospectionException(stopClass.getName()
-		    + " not superclass of " + beanClass.getName());
-	}
-
-	BeanDescriptor desc = null;
-	PropertyDescriptor[] props = null;
-	MethodDescriptor[] meths = null;
-	EventSetDescriptor[] events = null;
-	int dprops = -1;
-	int devents = -1;
-
-	// If we found a bean info, use as much of that as there is.
-	if (bean != null) {
-		desc = bean.getBeanDescriptor();
-		props = bean.getPropertyDescriptors();
-		meths = bean.getMethodDescriptors();
-		events = bean.getEventSetDescriptors();
-		dprops = bean.getDefaultPropertyIndex();
-		devents = bean.getDefaultEventIndex();
-	}
-
-	// Introspect the rest.
-	if (desc == null) {
-		desc = new BeanDescriptor(beanClass);
-	}
-	if (props == null) {
-		props = getProperties(beanClass, stopClass);
-	}
-	if (meths == null) {
-		meths = getMethods(beanClass, stopClass);
-	}
-	if (events == null) {
-		events = getListeners(beanClass, stopClass);
-	}
-
-	bean = new GenericBeanInfo(desc, props, meths, events, devents, dprops, bean);
-	cache.put(beanClass, bean);
-	return (bean);
-}
-
-public static String[] getBeanInfoSearchPath() {
-	return (beansearch);
-}
-
-private static EventSetDescriptor[] getListeners(Class startClass, Class stopClass) throws IntrospectionException {
-	Hashtable addMethods = new Hashtable();
-	Hashtable removeMethods = new Hashtable();
-	Hashtable keys = new Hashtable();
-	Hashtable listenerClasses = new Hashtable();
-
-	for (Class cls = startClass; cls != stopClass; cls = cls.getSuperclass()) {
-		Method[] meths = cls.getDeclaredMethods();
-		for (int i = 0; i < meths.length; i++) {
-			Method method = meths[i];
-			int modifiers = method.getModifiers();
-			if (Modifier.isPublic(modifiers) && !Modifier.isStatic(modifiers)) {
-				String mname = method.getName();
-				if (mname.startsWith(ADD) && mname.endsWith(LISTENER)) {
-					mname = mname.substring(ADD_LENGTH, mname.length() - LISTENER_LENGTH);
-					keys.put(mname, mname);
-					/* XXX: Do we need to check that
-					 * there's only one parameter?
-					 */
-					listenerClasses.put(mname, method.getParameterTypes()[0]);
-					if (addMethods.get(mname) == null) {
-						addMethods.put(mname, method);
-					}
-				}
-				else if (mname.startsWith(REMOVE) && mname.endsWith(LISTENER)) {
-					mname = mname.substring(REMOVE_LENGTH, mname.length() - LISTENER_LENGTH);
-					keys.put(mname, mname);
-					if (removeMethods.get(mname) == null) {
-						removeMethods.put(mname, method);
-					}
-				}
-			}
-		}
-	}
-
-	// Now look through add/remove methods and create descriptors.
-	EventSetDescriptor props[] = new EventSetDescriptor[keys.size()];
-	Enumeration k = keys.elements();
-	for (int i = 0; i < props.length; i++) {
-		String key = (String)k.nextElement();
-		Method add = (Method)addMethods.get(key);
-		Method remove = (Method)removeMethods.get(key);
-		Class listenerType = (Class)listenerClasses.get(key);
-		if (add != null && remove != null) {
-			props[i] = new EventSetDescriptor(decapitalize(key), listenerType, listenerType.getDeclaredMethods(), add, remove);
-
-			Class except[] = add.getExceptionTypes();
-			if (except != null) {
-				for (int j = 0; j < except.length; j++) {
-					try {
-						if (except[j].newInstance() instanceof TooManyListenersException) {
-							props[i].setUnicast(true);
-							break;
-						}
-					}
-					catch (IllegalAccessException _) {
-				}
-					catch (InstantiationException _) {
-					}
-				}
-			}
-		}
-	}
-
-	return (props);
-}
-
-private static MethodDescriptor[] getMethods(Class startClass, Class stopClass) throws IntrospectionException {
-	Hashtable hash = new Hashtable();
-
-	for (Class cls = startClass; cls != stopClass; cls = cls.getSuperclass()) {
-		Method[] meths = cls.getDeclaredMethods();
-		for (int i = 0; i < meths.length; i++) {
-
-			if (!Modifier.isPublic(meths[i].getModifiers())) {
-				continue;
-			}
-
-			String mname = meths[i].toString();
-			if (hash.get(mname) == null) {
-				hash.put(mname, meths[i]);
-			}
-		}
-	}
-
-	MethodDescriptor[] methdesc = new MethodDescriptor[hash.size()];
-	Enumeration e = hash.elements();
-	for (int i = 0; i < methdesc.length; i++) {
-		methdesc[i] = new MethodDescriptor((Method)e.nextElement());
-	}
-
-	return (methdesc);
-}
-
-private static PropertyDescriptor[] getProperties(Class startClass, Class stopClass) throws IntrospectionException {
-	Hashtable setMethods = new Hashtable();
-	Hashtable getMethods = new Hashtable();
-	Hashtable setIdxMethods = new Hashtable();
-	Hashtable getIdxMethods = new Hashtable();
-	Hashtable keys = new Hashtable();
-
-	for (Class cls = startClass; cls != stopClass; cls = cls.getSuperclass()) {
-		Method[] meths = cls.getDeclaredMethods();
-		for (int i = 0; i < meths.length; i++) {
-
-			Method meth = meths[i];
-
-			// We should only consider public non-statics.
-			int mod = meth.getModifiers();
-			if (!Modifier.isPublic(mod) || Modifier.isStatic(mod)) {
-				continue;
-			}
-
-			String mname = meth.getName();
-			Class[] mclasses = meth.getParameterTypes();
-
-			switch (mclasses.length) {
-			case 0:
-				if (mname.startsWith(GET)
-				    && !mname.equals(GET)) {
-					mname = mname.substring(GET_LENGTH);
-					keys.put(mname, mname);
-					if (getMethods.get(mname) == null) {
-						getMethods.put(mname, meth);
-					}
-				}
-				else if (mname.startsWith(IS)
-				    && !mname.equals(IS)) {
-					mname = mname.substring(IS_LENGTH);
-					keys.put(mname, mname);
-					if (getMethods.get(mname) == null) {
-						getMethods.put(mname, meth);
-					}
-				}
-				break;
-
-			case 1:
-				if (mname.startsWith(SET)
-				    && !mname.equals(SET)
-				    && meth.getReturnType().equals(Void.TYPE)) {
-					mname = mname.substring(SET_LENGTH);
-					keys.put(mname, mname);
-					if (setMethods.get(mname) == null) {
-						setMethods.put(mname, meth);
-					}
-				}
-				else if (mname.startsWith(GET)
-				    && !mname.equals(GET)
-				    && mclasses[0] == Integer.TYPE) {
-					mname = mname.substring(GET_LENGTH);
-					keys.put(mname, mname);
-					if (getIdxMethods.get(mname) == null) {
-						getIdxMethods.put(mname, meth);
-					}
-				}
-				break;
-
-			case 2:
-				if (mname.startsWith(SET)
-				    && !mname.equals(SET)
-				    && meth.getReturnType().equals(Void.TYPE)
-				    && mclasses[0] == Integer.TYPE) {
-					mname = mname.substring(SET_LENGTH);
-					keys.put(mname, mname);
-					if (setIdxMethods.get(mname) == null) {
-						setIdxMethods.put(mname, meth);
-					}
-				}
-				break;
-			}
-
-		}
-	}
-
-	// check if the bean fires PropertyChangeEvent
-	boolean bound = false;
-
-	try {
-	    startClass.getMethod(ADD_PROPERTY_CHANGE_LISTENER, new Class [] {PropertyChangeListener.class});
-	    bound = true;
-	}
-	catch (NoSuchMethodException e) {
-	    /* the bean does not allow to add property change listeners,
-	     * thus it does not fire poperty change events, i.e. its
-	     * properties are not bound.
-	     */
-	}
-
-	// Now look through set/get methods and create desciptors.
-	// Eliminate any methods that don't make sense.
-	PropertyDescriptor props[] = new PropertyDescriptor[keys.size()];
-
-	Enumeration k = keys.elements();
-	for (int i = 0; i < props.length; i++) {
-		String key = (String)k.nextElement();
-		Method set = (Method)setMethods.get(key);
-		Method get = (Method)getMethods.get(key);
-		Method setidx = (Method)setIdxMethods.get(key);
-		Method getidx = (Method)getIdxMethods.get(key);
-		if (setidx == null && getidx == null) {
-			if (get != null && set != null) {
-				if (!set.getReturnType().equals(Void.TYPE))
-					set = null;
-				else if (!get.getReturnType().equals(
-				    set.getParameterTypes()[0]))
-					get = null;
-			}
-			props[i] = new PropertyDescriptor(
-			    decapitalize(key), get, set);
-		}
-		else {
-			if (getidx != null && setidx != null) {
-				if (!setidx.getReturnType().equals(Void.TYPE))
-					setidx = null;
-				else if (!getidx.getReturnType().equals(
-				    setidx.getParameterTypes()[1]))
-					getidx = null;
-			}
-			props[i] = new IndexedPropertyDescriptor(
-			    decapitalize(key), get, set, getidx, setidx);
-		}
-
-		if (bound) {
-		    props[i].setBound(true);
-		}
-	}
-
-	return (props);
-}
-
-private static BeanInfo loadBeanInfo(Class beanClass) {
-	String bname = beanClass.getName();
-
-	// First try to load bean info from package.
-	BeanInfo bean = loadNamedBean(beanClass.getClassLoader(),
-	    bname + BEAN_INFO);
-	if (bean != null) {
-		return (bean);
-	}
-
-	// Extract the name of the bean without package information.
-	// We make allowances for both '.' and '/' seperators.
-	int pos = bname.lastIndexOf('.');
-	int spos = bname.lastIndexOf('/');
-	if (spos > pos) {
-		pos = spos;
-	}
-	bname = bname.substring(pos+1);
+package java.beans;
 
-	// Next try the search paths
-	for (int i = 0; i < beansearch.length; i++) {
-		bean = loadNamedBean(beanClass.getClassLoader(),
-		    beansearch[i] + "." + bname + BEAN_INFO);
-		if (bean != null) {
-			return (bean);
+import gnu.java.beans.*;
+import java.util.*;
+import java.lang.reflect.*;
+import gnu.java.lang.*;
+
+/**
+ * Introspector is the class that does the bulk of the
+ * design-time work in Java Beans.  Every class must have
+ * a BeanInfo in order for an RAD tool to use it; but, as
+ * promised, you don't have to write the BeanInfo class
+ * yourself if you don't want to.  All you have to do is
+ * call getBeanInfo() in the Introspector and it will use
+ * standard JavaBeans-defined method signatures to
+ * determine the information about your class.<P>
+ *
+ * Don't worry about it too much, though: you can provide
+ * JavaBeans with as much customized information as you
+ * want, or as little as you want, using the BeanInfo
+ * interface (see BeanInfo for details).<P>
+ *
+ * <STRONG>Order of Operations</STRONG><P>
+ *
+ * When you call getBeanInfo(class c), the Introspector
+ * first searches for BeanInfo class to see if you
+ * provided any explicit information.  It searches for a
+ * class named <bean class name>BeanInfo in different
+ * packages, first searching the bean class's package
+ * and then moving on to search the beanInfoSearchPath.<P>
+ *
+ * If it does not find a BeanInfo class, it acts as though
+ * it had found a BeanInfo class returning null from all
+ * methods (meaning it should discover everything through
+ * Introspection).  If it does, then it takes the
+ * information it finds in the BeanInfo class to be
+ * canonical (that is, the information speaks for its
+ * class as well as all superclasses).<P>
+ *
+ * When it has introspected the class, calls
+ * getBeanInfo(c.getSuperclass) and adds that information
+ * to the information it has, not adding to any information
+ * it already has that is canonical.<P>
+ *
+ * <STRONG>Introspection Design Patterns</STRONG><P>
+ *
+ * When the Introspector goes in to read the class, it
+ * follows a well-defined order in order to not leave any
+ * methods unaccounted for.  Its job is to step over all
+ * of the public methods in a class and determine whether
+ * they are part of a property, an event, or a method (in
+ * that order).
+ *
+ *
+ * <STRONG>Properties:</STRONG><P>
+ * 
+ * <OL>
+ * <LI>If there is a <CODE>public boolean isXXX()</CODE>
+ *     method, then XXX is a read-only boolean property.
+ *     <CODE>boolean getXXX()</CODE> may be supplied in
+ *     addition to this method, although isXXX() is the
+ *     one that will be used in this case and getXXX()
+ *     will be ignored.  If there is a
+ *     <CODE>public void setXXX(boolean)</CODE> method,
+ *     it is part of this group and makes it a read-write
+ *     property.</LI>
+ * <LI>If there is a
+ *     <CODE>public &lt;type&gt; getXXX(int)</CODE>
+ *     method, then XXX is a read-only indexed property of
+ *     type &lt;type&gt;.  If there is a
+ *     <CODE>public void setXXX(int,&lt;type&gt;)</CODE>
+ *     method, then it is a read-write indexed property of
+ *     type &lt;type&gt;.  There may also be a
+ *     <CODE>public &lt;type&gt;[] getXXX()</CODE> and a
+ *     <CODE>public void setXXX(&lt;type&gt;)</CODE>
+ *     method as well.</CODE></LI>
+ * <LI>If there is a
+ *     <CODE>public void setXXX(int,&lt;type&gt;)</CODE>
+ *     method, then it is a write-only indexed property of
+ *     type &lt;type&gt;.  There may also be a
+ *     <CODE>public &lt;type&gt;[] getXXX()</CODE> and a
+ *     <CODE>public void setXXX(&lt;type&gt;)</CODE>
+ *     method as well.</CODE></LI>
+ * <LI>If there is a
+ *     <CODE>public &lt;type&gt; getXXX()</CODE> method,
+ *     then XXX is a read-only property of type
+ *     &lt;type&gt;.  If there is a
+ *     <CODE>public void setXXX(&lt;type&gt;)</CODE>
+ *     method, then it will be used for the property and
+ *     the property will be considered read-write.</LI>
+ * <LI>If there is a
+ *     <CODE>public void setXXX(&lt;type&gt;)</CODE>
+ *     method, then as long as XXX is not already used as
+ *     the name of a property, XXX is assumed to be a
+ *     write-only property of type &lt;type&gt;.</LI>
+ * <LI>In all of the above cases, if the setXXX() method
+ *     throws <CODE>PropertyVetoException</CODE>, then the
+ *     property in question is assumed to be constrained.
+ *     No properties are ever assumed to be bound
+ *     (<STRONG>Spec Note:</STRONG> this is not in the
+ *     spec, it just makes sense).  See PropertyDescriptor
+ *     for a description of bound and constrained
+ *     properties.</LI>
+ * </OL>
+ *
+ * <STRONG>Events:</STRONG><P>
+ *
+ * If there is a pair of methods,
+ * <CODE>public void addXXX(&lt;type&gt;)</CODE> and
+ * <CODE>public void removeXXX(&lt;type&gt;)</CODE>, where
+ * &lt;type&gt; is a descendant of
+ * <CODE>java.util.EventListener</CODE>, then the pair of
+ * methods imply that this Bean will fire events to
+ * listeners of type &lt;type&gt;.<P>
+ *
+ * If the addXXX() method throws
+ * <CODE>java.util.TooManyListenersException</CODE>, then
+ * the event set is assumed to be <EM>unicast</EM>.  See
+ * EventSetDescriptor for a discussion of unicast event
+ * sets.<P>
+ *
+ * <STRONG>Spec Note:</STRONG> the spec seems to say that
+ * the listener type's classname must be equal to the XXX
+ * part of addXXX() and removeXXX(), but that is not the
+ * case in Sun's implementation, so I am assuming it is
+ * not the case in general.<P>
+ *
+ * <STRONG>Methods:</STRONG><P>
+ * 
+ * Any public methods (including those which were used
+ * for Properties or Events) are used as Methods.
+ *
+ * @author John Keiser
+ * @since JDK1.1
+ * @see java.beans.BeanInfo
+ */
+public class Introspector {
+  
+  public static final int USE_ALL_BEANINFO = 1;
+  public static final int IGNORE_IMMEDIATE_BEANINFO = 2;
+  public static final int IGNORE_ALL_BEANINFO = 3;
+
+  static String[] beanInfoSearchPath = {"gnu.java.beans.info"};
+  static Hashtable beanInfoCache = new Hashtable();
+  
+  private Introspector() {}
+  
+  /** 
+   * Get the BeanInfo for class <CODE>beanClass</CODE>,
+   * first by looking for explicit information, next by
+   * using standard design patterns to determine
+   * information about the class.
+   *
+   * @param beanClass the class to get BeanInfo about.
+   * @return the BeanInfo object representing the class.
+   */
+  public static BeanInfo getBeanInfo(Class beanClass) 
+    throws IntrospectionException 
+  {
+    BeanInfo cachedInfo;
+    synchronized(beanClass) 
+      {
+	cachedInfo = (BeanInfo)beanInfoCache.get(beanClass);
+	if(cachedInfo != null) 
+	  {
+	    return cachedInfo;
+	  }
+	cachedInfo = getBeanInfo(beanClass,null);
+	beanInfoCache.put(beanClass,cachedInfo);
+	return cachedInfo;
+      }
+  }
+
+  /**
+   * Flush all of the Introspector's internal caches.
+   *
+   * @since 1.2
+   */
+  public static void flushCaches()
+  {
+    beanInfoCache.clear();
+  }
+
+  /**
+   * Flush the Introspector's internal cached information for a given
+   * class.
+   *
+   * @param clz the class to be flushed.
+   * @throws NullPointerException if clz is null.
+   * @since 1.2
+   */
+  public static void flushFromCaches(Class clz)
+  {
+    synchronized (clz)
+      {
+	beanInfoCache.remove(clz);
+      }
+  }
+
+  /** 
+   * Get the BeanInfo for class <CODE>beanClass</CODE>,
+   * first by looking for explicit information, next by
+   * using standard design patterns to determine
+   * information about the class.  It crawls up the
+   * inheritance tree until it hits <CODE>topClass</CODE>.
+   *
+   * @param beanClass the Bean class.
+   * @param stopClass the class to stop at.
+   * @return the BeanInfo object representing the class.
+   */
+  public static BeanInfo getBeanInfo(Class beanClass, Class stopClass) 
+    throws IntrospectionException 
+  {
+    ExplicitInfo explicit = new ExplicitInfo(beanClass,stopClass);
+    
+    IntrospectionIncubator ii = new IntrospectionIncubator();
+    ii.setPropertyStopClass(explicit.propertyStopClass);
+    ii.setEventStopClass(explicit.eventStopClass);
+    ii.setMethodStopClass(explicit.methodStopClass);
+    ii.addMethods(beanClass.getMethods());
+    
+    BeanInfoEmbryo currentInfo = ii.getBeanInfoEmbryo();
+    PropertyDescriptor[] p = explicit.explicitPropertyDescriptors;
+    if(p!=null) 
+      {
+	for(int i=0;i<p.length;i++) 
+	  {
+	    if(!currentInfo.hasProperty(p[i])) 
+	      {
+		currentInfo.addProperty(p[i]);
+	      }
+	  }
+	if(explicit.defaultProperty != -1) 
+	  {
+	    currentInfo.setDefaultPropertyName(p[explicit.defaultProperty].getName());
+	  }
+      }
+    EventSetDescriptor[] e = explicit.explicitEventSetDescriptors;
+    if(e!=null) 
+      {
+	for(int i=0;i<e.length;i++) 
+	  {
+	    if(!currentInfo.hasEvent(e[i])) 
+	      {
+		currentInfo.addEvent(e[i]);
+	      }
+	  }
+	if(explicit.defaultEvent != -1) 
+	  {
+	    currentInfo.setDefaultEventName(e[explicit.defaultEvent].getName());
+	  }
+      }
+    MethodDescriptor[] m = explicit.explicitMethodDescriptors;
+    if(m!=null) 
+      {
+	for(int i=0;i<m.length;i++) 
+	  {
+	    if(!currentInfo.hasMethod(m[i])) 
+	      {
+		currentInfo.addMethod(m[i]);
+	      }
+	  }
+      }
+    
+    if(explicit.explicitBeanDescriptor != null) 
+      {
+	currentInfo.setBeanDescriptor(new BeanDescriptor(beanClass,explicit.explicitBeanDescriptor.getCustomizerClass()));
+      } 
+    else 
+      {
+	currentInfo.setBeanDescriptor(new BeanDescriptor(beanClass,null));
+      }
+    
+    currentInfo.setAdditionalBeanInfo(explicit.explicitBeanInfo);
+    currentInfo.setIcons(explicit.im);
+    
+    return currentInfo.getBeanInfo();
+  }
+  
+  /** 
+   * Get the search path for BeanInfo classes.
+   *
+   * @return the BeanInfo search path.
+   */
+  public static String[] getBeanInfoSearchPath() 
+  {
+    return beanInfoSearchPath;
+  }
+  
+  /** 
+   * Set the search path for BeanInfo classes.
+   * @param beanInfoSearchPath the new BeanInfo search
+   *        path.
+   */
+  public static void setBeanInfoSearchPath(String[] beanInfoSearchPath) 
+  {
+    Introspector.beanInfoSearchPath = beanInfoSearchPath;
+  }
+  
+  /** 
+   * A helper method to convert a name to standard Java
+   * naming conventions: anything with two capitals as the
+   * first two letters remains the same, otherwise the
+   * first letter is decapitalized.  URL = URL, I = i,
+   * MyMethod = myMethod.
+   *
+   * @param name the name to decapitalize.
+   * @return the decapitalized name.
+   */
+  public static String decapitalize(String name) 
+  {
+    try 
+      {
+      if(!Character.isUpperCase(name.charAt(0))) 
+	{
+	  return name;
+	} 
+      else 
+	{
+	try 
+	  {
+	  if(Character.isUpperCase(name.charAt(1))) 
+	    {
+	      return name;
+	    } 
+	  else 
+	    {
+	      char[] c = name.toCharArray();
+	      c[0] = Character.toLowerCase(c[0]);
+	      return new String(c);
+	    }
+	  } 
+	catch(StringIndexOutOfBoundsException E) 
+	  {
+	    char[] c = new char[1];
+	    c[0] = Character.toLowerCase(name.charAt(0));
+	    return new String(c);
+	  }
+	}
+      } 
+    catch(StringIndexOutOfBoundsException E) 
+      {
+	return name;
+      } 
+    catch(NullPointerException E) 
+      {
+	return null;
+      }
+  }
+  
+  static BeanInfo copyBeanInfo(BeanInfo b) 
+  {
+    java.awt.Image[] icons = new java.awt.Image[4];
+    for(int i=1;i<=4;i++) 
+      {
+	icons[i-1] = b.getIcon(i);
+      }
+    return new ExplicitBeanInfo(b.getBeanDescriptor(),
+				b.getAdditionalBeanInfo(),
+				b.getPropertyDescriptors(),
+				b.getDefaultPropertyIndex(),
+				b.getEventSetDescriptors(),
+				b.getDefaultEventIndex(),
+				b.getMethodDescriptors(),icons);
+  }
+}
+
+class ExplicitInfo 
+{
+  BeanDescriptor explicitBeanDescriptor;
+  BeanInfo[] explicitBeanInfo;
+  
+  PropertyDescriptor[] explicitPropertyDescriptors;
+  EventSetDescriptor[] explicitEventSetDescriptors;
+  MethodDescriptor[] explicitMethodDescriptors;
+  
+  int defaultProperty;
+  int defaultEvent;
+  
+  java.awt.Image[] im = new java.awt.Image[4];
+  
+  Class propertyStopClass;
+  Class eventStopClass;
+  Class methodStopClass;
+  
+  ExplicitInfo(Class beanClass, Class stopClass) 
+  {
+    while(beanClass != null && !beanClass.equals(stopClass)) 
+      {
+	BeanInfo explicit = findExplicitBeanInfo(beanClass);
+	if(explicit != null) 
+	  {
+	    if(explicitBeanDescriptor == null) 
+	      {
+		explicitBeanDescriptor = explicit.getBeanDescriptor();
+	      }
+	    if(explicitBeanInfo == null) 
+	      {
+		explicitBeanInfo = explicit.getAdditionalBeanInfo();
+	      }
+	    if(explicitPropertyDescriptors == null) 
+	      {
+		if(explicit.getPropertyDescriptors() != null) 
+		  {
+		    explicitPropertyDescriptors = explicit.getPropertyDescriptors();
+		    defaultProperty = explicit.getDefaultPropertyIndex();
+		    propertyStopClass = beanClass;
+		  }
+	      }
+	    if(explicitEventSetDescriptors == null) 
+	      {
+		if(explicit.getEventSetDescriptors() != null) 
+		  {
+		    explicitEventSetDescriptors = explicit.getEventSetDescriptors();
+		    defaultEvent = explicit.getDefaultEventIndex();
+		    eventStopClass = beanClass;
+		  }
+	      }
+	    if(explicitMethodDescriptors == null) 
+	      {
+		if(explicit.getMethodDescriptors() != null) 
+		  {
+		    explicitMethodDescriptors = explicit.getMethodDescriptors();
+		    methodStopClass = beanClass;
+		  }
+	      }
+	    if(im[0] == null && im[1] == null 
+	       && im[2] == null && im[3] == null) 
+	      {
+		im[0] = explicit.getIcon(0);
+		im[1] = explicit.getIcon(1);
+		im[2] = explicit.getIcon(2);
+		im[3] = explicit.getIcon(3);
+	      }
+	  }
+	beanClass = beanClass.getSuperclass();
+      }
+    if(propertyStopClass == null) 
+      {
+	propertyStopClass = stopClass;
+      }
+    if(eventStopClass == null) 
+      {
+	eventStopClass = stopClass;
+      }
+    if(methodStopClass == null) 
+      {
+	methodStopClass = stopClass;
+      }
+  }
+  
+  static Hashtable explicitBeanInfos = new Hashtable();
+  static Vector emptyBeanInfos = new Vector();
+  
+  static BeanInfo findExplicitBeanInfo(Class beanClass) 
+  {
+    BeanInfo retval = (BeanInfo)explicitBeanInfos.get(beanClass);
+    if(retval != null) 
+      {
+	return retval;
+      } 
+    else if(emptyBeanInfos.indexOf(beanClass) != -1) 
+      {
+	return null;
+      } 
+    else 
+      {
+	retval = reallyFindExplicitBeanInfo(beanClass);
+	if(retval != null) 
+	  {
+	    explicitBeanInfos.put(beanClass,retval);
+	  } 
+	else 
+	  {
+	    emptyBeanInfos.addElement(beanClass);
+	  }
+	return retval;
+      }
+  }
+  
+  static BeanInfo reallyFindExplicitBeanInfo(Class beanClass) 
+  {
+    try 
+      {
+      try 
+	{
+	  return (BeanInfo)Class.forName(beanClass.getName()+"BeanInfo").newInstance();
+	} 
+      catch(ClassNotFoundException E) 
+	{
+	}
+      String newName = ClassHelper.getTruncatedClassName(beanClass) + "BeanInfo";
+      for(int i=0;i<Introspector.beanInfoSearchPath.length;i++) 
+	{
+	  try 
+	    {
+	      if(Introspector.beanInfoSearchPath[i].equals("")) 
+		{
+		  return (BeanInfo)Class.forName(newName).newInstance();
+		} 
+	      else 
+		{
+		  return (BeanInfo)Class.forName(Introspector.beanInfoSearchPath[i] + "." + newName).newInstance();
 		}
-	}
-
-	return (null);
-}
-
-private static BeanInfo loadNamedBean(ClassLoader loader, String cl) {
-	try {
-		return (BeanInfo)Class.forName(cl, true, loader).newInstance();
-	}
-	catch (ClassNotFoundException _) {
-	}
-	catch (ClassCastException _) {
-	}
-	catch (IllegalAccessException _) {
-	}
-	catch (InstantiationException _) {
-	}
-	return (null);
-}
-
-public static void setBeanInfoSearchPath(String path[]) {
-	beansearch = path;
-}
+	    } 
+	  catch(ClassNotFoundException E) 
+	    {
+	    }
+	}
+      } 
+    catch(IllegalAccessException E) 
+      {
+      } 
+    catch(InstantiationException E) 
+      {
+      }
+    return null;
+  }
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/beans/ParameterDescriptor.java kaffe/libraries/javalib/java/beans/ParameterDescriptor.java
--- kaffe_orig/libraries/javalib/java/beans/ParameterDescriptor.java	2003-09-26 14:19:21.000000000 +1200
+++ kaffe/libraries/javalib/java/beans/ParameterDescriptor.java	2003-10-11 14:37:13.000000000 +1300
@@ -1,20 +1,59 @@
 /*
- * Java core library component.
  *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ * Imported from GNU Classpath by M.Negovanovic
  *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
  */
 
-package java.beans;
 
-public class ParameterDescriptor extends FeatureDescriptor {
+/* java.beans.MethodDescriptor
+   Copyright (C) 1998 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
 
-  public ParameterDescriptor()
-  {
-    super();
-  }
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
 
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
+package java.beans;
+
+/** ParameterDescriptor represents a single parameter to a method.
+ ** As it turns out, FeatureDescriptor is sufficient to hold all
+ ** the information.  Use its constructor and methods to set
+ ** the appropriate values.
+ **
+ ** @author John Keiser
+ ** @since JDK1.1
+ ** @version 1.1.0, 26 Jul 1998
+ **/
+public class ParameterDescriptor extends FeatureDescriptor {
+	
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/beans/PropertyChangeEvent.java kaffe/libraries/javalib/java/beans/PropertyChangeEvent.java
--- kaffe_orig/libraries/javalib/java/beans/PropertyChangeEvent.java	2003-09-26 14:19:21.000000000 +1200
+++ kaffe/libraries/javalib/java/beans/PropertyChangeEvent.java	2003-10-11 14:37:30.000000000 +1300
@@ -1,57 +1,196 @@
 /*
- * Java core library component.
  *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ * Imported from GNU Classpath by M.Negovanovic
  *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
  */
 
+
+/* PropertyChangeEvent.java -- describes a change in a property
+   Copyright (C) 1998, 2000, 2002 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
 package java.beans;
 
 import java.util.EventObject;
 
-public class PropertyChangeEvent extends EventObject {
-
-  // NB: these are all part of the serial form
-  private String propertyName;
-  private Object oldValue;
-  private Object newValue;
+/**
+ * PropertyChangeEvents are fired in the PropertyChange and VetoableChange
+ * event classes.  They represent the old and new values as well as the
+ * source Bean. If the old or new value is a primitive type, it must be
+ * wrapped in the appropriate wrapper type (java.lang.Integer for int, etc.,
+ * etc.).
+ *
+ * <p>If the old or new values are unknown (although why that would be I do
+ * not know), they may be null. Also, if the set of properties itself has
+ * changed, the name should be null, and the old and new values may also be
+ * null. Right now Sun put in a propagationId, reserved for future use. Read
+ * the comments on the constructor and on setPropagationId for more
+ * information.
+ *
+ * @author John Keiser
+ * @author Eric Blake <ebb9@email.byu.edu>
+ * @since 1.1
+ * @status udpated to 1.4
+ */
+public class PropertyChangeEvent extends EventObject
+{
+  /**
+   * Compatible with JDK 1.1+.
+   */
+  private static final long serialVersionUID = 7042693688939648123L;
+
+  /**
+   * The name of the property that changed, may be null. Package visible for
+   * use by PropertyChangeSupport.
+   *
+   * @serial the changed property name
+   */
+  final String propertyName;
+
+  /**
+   * The new value of the property, may be null. Package visible for use by
+   * PropertyChangeSupport.
+   *
+   * @serial the new property value
+   */
+  final Object newValue;
+
+  /**
+   * The old value of the property, may be null. Package visible for use by
+   * PropertyChangeSupport.
+   *
+   * @serial the old property value
+   */
+  final Object oldValue;
+
+  /**
+   * The propagation ID, reserved for future use. May be null.
+   *
+   * @see #getPropagationId()
+   * @serial the Propagation ID
+   */
   private Object propagationId;
 
-  public PropertyChangeEvent(Object source, String propertyName, Object oldValue, Object newValue)
+  /**
+   * Create a new PropertyChangeEvent. Remember that if you received a
+   * PropertyChangeEvent and are sending a new one, you should also set the
+   * propagation ID from the old PropertyChangeEvent.
+   *
+   * @param source the Bean containing the property
+   * @param propertyName the property's name
+   * @param oldValue the old value of the property
+   * @param newValue the new value of the property
+   * @throws IllegalArgumentException if source is null
+   */
+  public PropertyChangeEvent(Object source, String propertyName,
+                             Object oldVal, Object newVal)
   {
     super(source);
     this.propertyName = propertyName;
-    this.oldValue = oldValue;
-    this.newValue = newValue;
-    propagationId = null;
+    oldValue = oldVal;
+    newValue = newVal;
   }
 
+  /**
+   * Get the property name. May be null if multiple properties changed.
+   *
+   * @return the property name
+   */
   public String getPropertyName()
   {
-    return (propertyName);
+    return propertyName;
   }
 
+  /**
+   * Get the property's new value. May be null if multiple properties changed.
+   *
+   * @return the property's new value
+   */
   public Object getNewValue()
   {
-    return (newValue);
+    return newValue;
   }
 
+  /**
+   * Get the property's old value. May be null if multiple properties changed.
+   *
+   * @return the property's old value
+   */
   public Object getOldValue()
   {
-    return (oldValue);
+    return oldValue;
   }
 
+  /**
+   * Set the propagation ID.  This is a way for the event to be passed from
+   * hand to hand and retain a little extra state.  Right now it is unused,
+   * but it should be propagated anyway so that future versions of JavaBeans
+   * can use it, for God knows what.
+   *
+   * @param propagationId the propagation ID
+   * @see #getPropagationId()
+   */
   public void setPropagationId(Object propagationId)
   {
     this.propagationId = propagationId;
   }
 
+  /**
+   * Get the propagation ID. Right now, it is not used for anything.
+   *
+   * @return the propagation ID
+   * @see #setPropagationId(Object)
+   */
   public Object getPropagationId()
   {
-    return (propagationId);
+    return propagationId;
   }
 
-}
+  /**
+   * Utility method to rollback a change.
+   *
+   * @param event the event to rollback
+   * @return a new event with old and new swapped
+   */
+  PropertyChangeEvent rollback()
+  {
+    PropertyChangeEvent result
+      = new PropertyChangeEvent(source, propertyName, newValue, oldValue);
+    result.propagationId = propagationId;
+    return result;
+  }
+} // class PropertyChangeEvent
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/beans/PropertyChangeSupport.java kaffe/libraries/javalib/java/beans/PropertyChangeSupport.java
--- kaffe_orig/libraries/javalib/java/beans/PropertyChangeSupport.java	2003-09-26 14:19:21.000000000 +1200
+++ kaffe/libraries/javalib/java/beans/PropertyChangeSupport.java	2003-10-11 14:37:50.000000000 +1300
@@ -1,106 +1,495 @@
+/*
+ *
+ * Imported from GNU Classpath by M.Negovanovic
+ *
+ */
+
+
+/* PropertyChangeSupport.java -- support to manage property change listeners
+   Copyright (C) 1998, 1999, 2000, 2002 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
 package java.beans;
 
+import java.io.IOException;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
 import java.io.Serializable;
-import java.util.HashMap;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Hashtable;
+import java.util.Iterator;
+import java.util.Map.Entry;
 import java.util.Vector;
 
-/*
- * Java core library component.
- *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+/**
+ * PropertyChangeSupport makes it easy to fire property change events and
+ * handle listeners. It allows chaining of listeners, as well as filtering
+ * by property name. In addition, it will serialize only those listeners
+ * which are serializable, ignoring the others without problem. This class
+ * is thread-safe.
  *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
+ * @author John Keiser
+ * @author Eric Blake <ebb9@email.byu.edu>
+ * @since 1.1
+ * @status updated to 1.4
  */
-public class PropertyChangeSupport
-  implements Serializable
+public class PropertyChangeSupport implements Serializable
 {
-	private static final long serialVersionUID = 6401253773779951803L;
-	private final HashMap PROPERTY_LISTENERS = new HashMap();
-	private Object source;
-
-public PropertyChangeSupport(Object sourceBean) {
-	source = sourceBean;
-}
-
-public synchronized void addPropertyChangeListener(String property, PropertyChangeListener listener) {
-	if (!PROPERTY_LISTENERS.containsKey(property)) {
-			PROPERTY_LISTENERS.put(property, new Vector());
-	}
-	
-	((Vector) PROPERTY_LISTENERS.get(property)).addElement(listener);
-}
-
-public synchronized void addPropertyChangeListener(PropertyChangeListener listener) {
-	addPropertyChangeListener(null, listener);
-}
-
-public void firePropertyChange(String propertyName, boolean oldValue, boolean newValue) {
-	if ((oldValue == newValue) ||
-	    (!PROPERTY_LISTENERS.containsKey(null) && !PROPERTY_LISTENERS.containsKey(propertyName))) {
-		return;
-	}
-
-	firePropertyChange (propertyName, new PropertyChangeEvent (source, propertyName,
-								   new Boolean (oldValue),
-								   new Boolean (newValue)));
-}
-
-public void firePropertyChange(String propertyName, int oldValue, int newValue) {
-        if ((oldValue == newValue) ||
-            (!PROPERTY_LISTENERS.containsKey(null) && !PROPERTY_LISTENERS.containsKey(propertyName))) {
-                return;
-        }
-            
-        firePropertyChange (propertyName, new PropertyChangeEvent (source, propertyName,
-                                                                   new Integer (oldValue),
-                                                                   new Integer (newValue)));
-}
-
-public void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
-	if ((oldValue!=null && oldValue.equals(newValue)) ||  
-	    (!PROPERTY_LISTENERS.containsKey(null) && !PROPERTY_LISTENERS.containsKey(propertyName))) {
-		return;
-	}
-
-	firePropertyChange (propertyName, new PropertyChangeEvent (source, propertyName,
-								   oldValue, newValue));
-}
-
-public void firePropertyChange (String propertyName, PropertyChangeEvent pce) {
-	// Is anyone interested ?
-	Vector vec = (Vector) PROPERTY_LISTENERS.get (propertyName);
-        if (vec == null) {
-        	vec = (Vector) PROPERTY_LISTENERS.get (null);
-        } else {
-		vec = ((Vector)vec.clone());
-                vec.addAll((Vector) PROPERTY_LISTENERS.get(null));
-	}
-
-        if (vec==null) {
-		return;
-	}
-
-	int size;
-	synchronized (this) {
-		size = vec.size();
-		if (size == 0) {
-			return;
-		}
-	}
-	for (int dis = 0; dis < size; dis++) {
-		((PropertyChangeListener)vec.elementAt(dis)).propertyChange(pce);
-	}
-}
-
-public synchronized void removePropertyChangeListener(PropertyChangeListener listener) {
-	removePropertyChangeListener(null, listener);
-}
-
-public synchronized void removePropertyChangeListener(String property, PropertyChangeListener listener) {
-	if (PROPERTY_LISTENERS.containsKey(property)) {
-		((Vector) PROPERTY_LISTENERS.get(property)).removeElement(listener);
-	}
-}
-}
+  /**
+   * Compatible with JDK 1.1+.
+   */
+  private static final long serialVersionUID = 6401253773779951803L;
+
+  /**
+   * Maps property names (String) to named listeners (PropertyChangeSupport).
+   * If this is a child instance, this field will be null.
+   *
+   * @serial the map of property names to named listener managers
+   * @since 1.2
+   */
+  private Hashtable children;
+
+  /**
+   * The non-null source object for any generated events.
+   *
+   * @serial the event source
+   */
+  private final Object source;
+
+  /**
+   * A field to compare serialization versions - this class uses version 2.
+   *
+   * @serial the serialization format
+   */
+  private final int propertyChangeSupportSerializedDataVersion = 2;
+
+  /**
+   * The list of all registered property listeners. If this instance was
+   * created by user code, this only holds the global listeners (ie. not tied
+   * to a name), and may be null. If it was created by this class, as a
+   * helper for named properties, then this vector will be non-null, and this
+   * instance appears as a value in the <code>children</code> hashtable of
+   * another instance, so that the listeners are tied to the key of that
+   * hashtable entry.
+   */
+  private transient Vector listeners;
+
+  /**
+   * Create a PropertyChangeSupport to work with a specific source bean.
+   *
+   * @param source the source bean to use
+   * @throws NullPointerException if source is null
+   */
+  public PropertyChangeSupport(Object source)
+  {
+    this.source = source;
+    if (source == null)
+      throw new NullPointerException();
+  }
+
+  /**
+   * Adds a PropertyChangeListener to the list of global listeners. All
+   * property change events will be sent to this listener. The listener add
+   * is not unique: that is, <em>n</em> adds with the same listener will
+   * result in <em>n</em> events being sent to that listener for every
+   * property change. Adding a null listener may cause a NullPointerException
+   * down the road. This method will unwrap a PropertyChangeListenerProxy,
+   * registering the underlying delegate to the named property list.
+   *
+   * @param l the listener to add
+   */
+  public synchronized void addPropertyChangeListener(PropertyChangeListener l)
+  {
+    if (l instanceof PropertyChangeListenerProxy)
+      {
+        PropertyChangeListenerProxy p = (PropertyChangeListenerProxy) l;
+        addPropertyChangeListener(p.propertyName,
+                                  (PropertyChangeListener) p.getListener());
+      }
+    else
+      {
+        if (listeners == null)
+          listeners = new Vector();
+        listeners.add(l);
+      }
+  }
+
+  /**
+   * Removes a PropertyChangeListener from the list of global listeners. If
+   * any specific properties are being listened on, they must be deregistered
+   * by themselves; this will only remove the general listener to all
+   * properties. If <code>add()</code> has been called multiple times for a
+   * particular listener, <code>remove()</code> will have to be called the
+   * same number of times to deregister it. This method will unwrap a
+   * PropertyChangeListenerProxy, removing the underlying delegate from the
+   * named property list.
+   *
+   * @param l the listener to remove
+   */
+  public synchronized void
+    removePropertyChangeListener(PropertyChangeListener l)
+  {
+    if (l instanceof PropertyChangeListenerProxy)
+      {
+        PropertyChangeListenerProxy p = (PropertyChangeListenerProxy) l;
+        removePropertyChangeListener(p.propertyName,
+                                     (PropertyChangeListener) p.getListener());
+      }
+    else if (listeners != null)
+      {
+        listeners.remove(l);
+        if (listeners.isEmpty())
+          listeners = null;
+      }
+  }
+
+  /**
+   * Returns an array of all registered property change listeners. Those that
+   * were registered under a name will be wrapped in a
+   * <code>PropertyChangeListenerProxy</code>, so you must check whether the
+   * listener is an instance of the proxy class in order to see what name the
+   * real listener is registered under. If there are no registered listeners,
+   * this returns an empty array.
+   *
+   * @return the array of registered listeners
+   * @see PropertyChangeListenerProxy
+   * @since 1.4
+   */
+  public synchronized PropertyChangeListener[] getPropertyChangeListeners()
+  {
+    ArrayList list = new ArrayList();
+    if (listeners != null)
+      list.addAll(listeners);
+    if (children != null)
+      {
+        int i = children.size();
+        Iterator iter = children.entrySet().iterator();
+        while (--i >= 0)
+          {
+            Entry e = (Entry) iter.next();
+            String name = (String) e.getKey();
+            Vector v = ((PropertyChangeSupport) e.getValue()).listeners;
+            int j = v.size();
+            while (--j >= 0)
+              list.add(new PropertyChangeListenerProxy
+                (name, (PropertyChangeListener) v.get(j)));
+          }
+      }
+    return (PropertyChangeListener[])
+      list.toArray(new PropertyChangeListener[list.size()]);
+  }
+
+  /**
+   * Adds a PropertyChangeListener listening on the specified property. Events
+   * will be sent to the listener only if the property name matches. The
+   * listener add is not unique; that is, <em>n</em> adds on a particular
+   * property for a particular listener will result in <em>n</em> events
+   * being sent to that listener when that property is changed. The effect is
+   * cumulative, too; if you are registered to listen to receive events on
+   * all property changes, and then you register on a particular property,
+   * you will receive change events for that property twice. Adding a null
+   * listener may cause a NullPointerException down the road. This method
+   * will unwrap a PropertyChangeListenerProxy, registering the underlying
+   * delegate to the named property list if the names match, and discarding
+   * it otherwise.
+   *
+   * @param propertyName the name of the property to listen on
+   * @param l the listener to add
+   * @throws NullPointerException if propertyName is null
+   */
+  public synchronized void addPropertyChangeListener(String propertyName,
+                                                     PropertyChangeListener l)
+  {
+    while (l instanceof PropertyChangeListenerProxy)
+      {
+        PropertyChangeListenerProxy p = (PropertyChangeListenerProxy) l;
+        if (propertyName == null ? p.propertyName != null
+            : ! propertyName.equals(p.propertyName))
+          return;
+        l = (PropertyChangeListener) p.getListener();
+      }
+    PropertyChangeSupport s = null;
+    if (children == null)
+      children = new Hashtable();
+    else
+      s = (PropertyChangeSupport) children.get(propertyName);
+    if (s == null)
+      {
+        s = new PropertyChangeSupport(source);
+        s.listeners = new Vector();
+        children.put(propertyName, s);
+      }
+    s.listeners.add(l);
+  }
+
+  /**
+   * Removes a PropertyChangeListener from listening to a specific property.
+   * If <code>add()</code> has been called multiple times for a particular
+   * listener on a property, <code>remove()</code> will have to be called the
+   * same number of times to deregister it. This method will unwrap a
+   * PropertyChangeListenerProxy, removing the underlying delegate from the
+   * named property list if the names match.
+   *
+   * @param propertyName the property to stop listening on
+   * @param l the listener to remove
+   * @throws NullPointerException if propertyName is null
+   */
+  public synchronized void
+    removePropertyChangeListener(String propertyName, PropertyChangeListener l)
+  {
+    if (children == null)
+      return;
+    PropertyChangeSupport s
+      = (PropertyChangeSupport) children.get(propertyName);
+    if (s == null)
+      return;
+    while (l instanceof PropertyChangeListenerProxy)
+      {
+        PropertyChangeListenerProxy p = (PropertyChangeListenerProxy) l;
+        if (propertyName == null ? p.propertyName != null
+            : ! propertyName.equals(p.propertyName))
+          return;
+        l = (PropertyChangeListener) p.getListener();
+      }
+    s.listeners.remove(l);
+    if (s.listeners.isEmpty())
+      {
+        children.remove(propertyName);
+        if (children.isEmpty())
+          children = null;
+      }
+  }
+
+  /**
+   * Returns an array of all property change listeners registered under the
+   * given property name. If there are no registered listeners, this returns
+   * an empty array.
+   *
+   * @return the array of registered listeners
+   * @throws NullPointerException if propertyName is null
+   * @since 1.4
+   */
+  public synchronized PropertyChangeListener[]
+    getPropertyChangeListeners(String propertyName)
+  {
+    if (children == null)
+      return new PropertyChangeListener[0];
+    PropertyChangeSupport s
+      = (PropertyChangeSupport) children.get(propertyName);
+    if (s == null)
+      return new PropertyChangeListener[0];
+    return (PropertyChangeListener[])
+      s.listeners.toArray(new PropertyChangeListener[s.listeners.size()]);
+  }
+
+  /**
+   * Fire a PropertyChangeEvent containing the old and new values of the
+   * property to all the global listeners, and to all the listeners for the
+   * specified property name. This does nothing if old and new are non-null
+   * and equal.
+   *
+   * @param propertyName the name of the property that changed
+   * @param oldVal the old value
+   * @param newVal the new value
+   */
+  public void firePropertyChange(String propertyName,
+                                 Object oldVal, Object newVal)
+  {
+    firePropertyChange(new PropertyChangeEvent(source, propertyName,
+                                               oldVal, newVal));
+  }
+
+  /**
+   * Fire a PropertyChangeEvent containing the old and new values of the
+   * property to all the global listeners, and to all the listeners for the
+   * specified property name. This does nothing if old and new are equal.
+   *
+   * @param propertyName the name of the property that changed
+   * @param oldVal the old value
+   * @param newVal the new value
+   */
+  public void firePropertyChange(String propertyName, int oldVal, int newVal)
+  {
+    if (oldVal != newVal)
+      firePropertyChange(new PropertyChangeEvent(source, propertyName,
+                                                 new Integer(oldVal),
+                                                 new Integer(newVal)));
+  }
+
+  /**
+   * Fire a PropertyChangeEvent containing the old and new values of the
+   * property to all the global listeners, and to all the listeners for the
+   * specified property name. This does nothing if old and new are equal.
+   *
+   * @param propertyName the name of the property that changed
+   * @param oldVal the old value
+   * @param newVal the new value
+   */
+  public void firePropertyChange(String propertyName,
+                                 boolean oldVal, boolean newVal)
+  {
+    if (oldVal != newVal)
+      firePropertyChange(new PropertyChangeEvent(source, propertyName,
+                                                 Boolean.valueOf(oldVal),
+                                                 Boolean.valueOf(newVal)));
+  }
+
+  /**
+   * Fire a PropertyChangeEvent to all the global listeners, and to all the
+   * listeners for the specified property name. This does nothing if old and
+   * new values of the event are equal.
+   *
+   * @param event the event to fire
+   * @throws NullPointerException if event is null
+   */
+  public void firePropertyChange(PropertyChangeEvent event)
+  {
+    if (event.oldValue != null && event.oldValue.equals(event.newValue))
+      return;
+    Vector v = listeners; // Be thread-safe.
+    if (v != null)
+      {
+        int i = v.size();
+        while (--i >= 0)
+          ((PropertyChangeListener) v.get(i)).propertyChange(event);
+      }
+    Hashtable h = children; // Be thread-safe.
+    if (h != null && event.propertyName != null)
+      {
+        PropertyChangeSupport s
+          = (PropertyChangeSupport) h.get(event.propertyName);
+        if (s != null)
+          {
+            v = s.listeners; // Be thread-safe.
+            int i = v == null ? 0 : v.size();
+            while (--i >= 0)
+              ((PropertyChangeListener) v.get(i)).propertyChange(event);
+          }
+      }
+  }
+
+  /**
+   * Tell whether the specified property is being listened on or not. This
+   * will only return <code>true</code> if there are listeners on all
+   * properties or if there is a listener specifically on this property.
+   *
+   * @param propertyName the property that may be listened on
+   * @return whether the property is being listened on
+   * @throws NullPointerException if propertyName is null
+   */
+  public synchronized boolean hasListeners(String propertyName)
+  {
+    return listeners != null || (children != null
+                                 && children.get(propertyName) != null);
+  }
+
+  /**
+   * Saves the state of the object to the stream.
+   *
+   * @param s the stream to write to
+   * @throws IOException if anything goes wrong
+   * @serialData this writes out a null-terminated list of serializable
+   *             global property change listeners (the listeners for a named
+   *             property are written out as the global listeners of the
+   *             children, when the children hashtable is saved)
+   */
+  private synchronized void writeObject(ObjectOutputStream s)
+    throws IOException
+  {
+    s.defaultWriteObject();
+    if (listeners != null)
+      {
+        int i = listeners.size();
+        while (--i >= 0)
+          if (listeners.get(i) instanceof Serializable)
+            s.writeObject(listeners.get(i));
+      }
+    s.writeObject(null);
+  }
+
+  /**
+   * Reads the object back from stream (deserialization).
+   *
+   * XXX Since serialization for 1.1 streams was not documented, this may
+   * not work if propertyChangeSupportSerializedDataVersion is 1.
+   *
+   * @param s the stream to read from
+   * @throws IOException if reading the stream fails
+   * @throws ClassNotFoundException if deserialization fails
+   * @serialData this reads in a null-terminated list of serializable
+   *             global property change listeners (the listeners for a named
+   *             property are written out as the global listeners of the
+   *             children, when the children hashtable is saved)
+   */
+  private void readObject(ObjectInputStream s)
+    throws IOException, ClassNotFoundException
+  {
+    s.defaultReadObject();
+    PropertyChangeListener l = (PropertyChangeListener) s.readObject();
+    while (l != null)
+      {
+        addPropertyChangeListener(l);
+        l = (PropertyChangeListener) s.readObject();
+      }
+    // Sun is not as careful with children as we are, and lets some proxys
+    // in that can never receive events. So, we clean up anything that got
+    // serialized, to make sure our invariants hold.
+    if (children != null)
+      {
+        int i = children.size();
+        Iterator iter = children.entrySet().iterator();
+        while (--i >= 0)
+          {
+            Entry e = (Entry) iter.next();
+            String name = (String) e.getKey();
+            PropertyChangeSupport pcs = (PropertyChangeSupport) e.getValue();
+            if (pcs.listeners == null)
+              pcs.listeners = new Vector();
+            if (pcs.children != null)
+              pcs.listeners.addAll
+                (Arrays.asList(pcs.getPropertyChangeListeners(name)));
+            if (pcs.listeners.size() == 0)
+              iter.remove();
+            else
+              pcs.children = null;
+          }
+        if (children.size() == 0)
+          children = null;
+      }
+  }
+} // class PropertyChangeSupport
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/beans/PropertyEditorManager.java kaffe/libraries/javalib/java/beans/PropertyEditorManager.java
--- kaffe_orig/libraries/javalib/java/beans/PropertyEditorManager.java	2003-09-26 14:19:21.000000000 +1200
+++ kaffe/libraries/javalib/java/beans/PropertyEditorManager.java	2003-10-11 14:38:25.000000000 +1300
@@ -1,97 +1,220 @@
 /*
- * Java core library component.
  *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ * Imported from GNU Classpath by M.Negovanovic
  *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
  */
 
-package java.beans;
 
-import java.util.Hashtable;
+/* java.beans.PropertyEditorManager
+   Copyright (C) 1998 Free Software Foundation, Inc.
 
-public class PropertyEditorManager {
+This file is part of GNU Classpath.
 
-  private static String[] editorpath = { "kaffe.beans.editors" };
-  private static Hashtable assoc = new Hashtable();
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
-  public static void registerEditor(Class targetType, Class editorClass)
-  {
-    if (editorClass == null) {
-      assoc.remove(targetType);
-    }
-    else {
-      assoc.put(targetType, editorClass);
-    }
-  }
 
-  public static PropertyEditor findEditor(Class targetType)
-  {
-    PropertyEditor editor = (PropertyEditor)assoc.get(targetType);
-    if (editor == null) {
-      editor = loadPropertyEditor(targetType);
-    }
-    return (editor);
-  }
+package java.beans;
 
-  public static String[] getEditorSearchPath()
-  {
-    return (editorpath);
-  }
+import gnu.java.lang.ClassHelper;
+import gnu.java.beans.editors.ColorEditor;
+import gnu.java.beans.editors.FontEditor;
+import gnu.java.beans.editors.NativeBooleanEditor;
+import gnu.java.beans.editors.NativeByteEditor;
+import gnu.java.beans.editors.NativeDoubleEditor;
+import gnu.java.beans.editors.NativeFloatEditor;
+import gnu.java.beans.editors.NativeIntEditor;
+import gnu.java.beans.editors.NativeLongEditor;
+import gnu.java.beans.editors.NativeShortEditor;
+import gnu.java.beans.editors.StringEditor;
+import java.awt.Color;
+import java.awt.Font;
+
+/**
+ * PropertyEditorManager is used to find property editors
+ * for various types (not necessarily Beans).<P>
+ *
+ * It first checks to see if the property editor is
+ * already registered; if it is, that property editor is
+ * used.  Next it takes the type's classname and appends
+ * "Editor" to it, and searches first in the class's
+ * package and then in the property editor search path.<P>
+ *
+ * Default property editors are provided for:<P>
+ * <OL>
+ * <LI>boolean, byte, short, int, long, float, and double</LI>
+ * <LI>java.lang.String</LI>
+ * <LI>java.awt.Color</LI>
+ * <LI>java.awt.Font</LI>
+ * <OL>
+ *
+ * <STRONG>Spec Suggestion:</STRONG> Perhaps an editor for
+ * Filename or something like it should be provided.  As well
+ * as char.
+ *
+ * @author John Keiser
+ * @since 1.1
+ * @version 1.1.0, 29 Jul 1998
+ */
 
-  public static void setEditorSearchPath(String path[])
-  {
-    editorpath = path;
+public class PropertyEditorManager
+{
+  static java.util.Hashtable editors = new java.util.Hashtable();
+  static String[] editorSearchPath = { "gnu.java.beans.editors",
+                                       "sun.beans.editors" };
+
+  static
+    {
+      registerEditor(Boolean.TYPE, NativeBooleanEditor.class);
+      registerEditor(Byte.TYPE,    NativeByteEditor.class);
+      registerEditor(Short.TYPE,   NativeShortEditor.class);
+      registerEditor(Integer.TYPE, NativeIntEditor.class);
+      registerEditor(Long.TYPE,    NativeLongEditor.class);
+      registerEditor(Float.TYPE,   NativeFloatEditor.class);
+      registerEditor(Double.TYPE,  NativeDoubleEditor.class);
+      registerEditor(String.class, StringEditor.class);
+      registerEditor(Color.class,  ColorEditor.class);
+      registerEditor(Font.class,   FontEditor.class);
+    }
+
+  /**
+   * Beats me why this class can be instantiated, but there
+   * you have it.
+   */
+  public PropertyEditorManager()
+  {
+    // Do nothing here
+  }
+
+  /**
+   * Register an editor for a class.  Replaces old editor
+   * if there was one registered before.
+   *
+   * @param editedClass the class that the property editor
+   *        will edit.
+   * @param editorClass the PropertyEditor class.
+   */
+  public static void registerEditor(Class editedClass, Class editorClass)
+  {
+    editors.put(editedClass, editorClass);
+  }
+
+  /**
+   * Returns a new instance of the property editor for the
+   * specified class.
+   *
+   * @param editedClass the class that the property editor
+   *        will edit.
+   * @return a PropertyEditor instance that can edit the
+   *         specified class.
+   */
+  public static PropertyEditor findEditor(Class editedClass)
+  {
+    try
+      {
+        Class found = (Class)editors.get(editedClass);
+        if(found != null)
+          {
+            return (PropertyEditor)found.newInstance();
+          }
+
+	ClassLoader contextClassLoader
+		= Thread.currentThread().getContextClassLoader();
+
+        try
+          {
+            found = Class.forName(editedClass.getName()+"Editor", true,
+				  contextClassLoader);
+            registerEditor(editedClass,found);
+            return (PropertyEditor)found.newInstance();
+          }
+        catch(ClassNotFoundException E)
+          {
+          }
+
+        String appendName
+		= "."
+		+ ClassHelper.getTruncatedClassName(editedClass)
+		+ "Editor";
+        synchronized(editorSearchPath)
+          {
+            for(int i=0;i<editorSearchPath.length;i++)
+              {
+                try
+                  {
+                    found = Class.forName(editorSearchPath[i] + appendName,
+					  true, contextClassLoader);
+                    registerEditor(editedClass,found);
+                    return (PropertyEditor)found.newInstance();
+                  }
+                catch(ClassNotFoundException E)
+                  {
+                  }
+              }
+          }
+      }
+    catch(InstantiationException E)
+      {
+      }
+    catch(IllegalAccessException E)
+      {
+      }
+    
+    return null;
   }
 
-  private static PropertyEditor loadPropertyEditor(Class editorClass)
+  /**
+   * Get the editor search path.
+   * As a minor departure from the spec, the default value
+   * for the editor search path is "gnu.java.beans.editors",
+   * "sun.beans.editors".
+   *
+   * @return the editor search path.
+   */
+  public static String[] getEditorSearchPath()
   {
-    String editorname = editorClass.getName();
-
-    // First try to load editor from package.
-    PropertyEditor editor = loadNamedPropertyEditor(
-	editorClass.getClassLoader(), editorname + "Editor");
-    if (editor != null) {
-      return (editor);
-    }
-
-    // Extract the name without package information.
-    // We make allowances for both '.' and '/' seperators.
-    int pos = editorname.lastIndexOf('.');
-    int spos = editorname.lastIndexOf('/');
-    if (spos > pos) {
-      pos = spos;
-    }
-    editorname = editorname.substring(pos+1);
-
-    // Next try the search paths
-    for (int i = 0; i < editorpath.length; i++) {
-      editor = loadNamedPropertyEditor(editorClass.getClassLoader(),
-	editorpath[i] + "." + editorname + "Editor");
-      if (editor != null) {
-	return (editor);
-      }
-    }
-
-    return (null);
+    return editorSearchPath;
   }
 
-  private static PropertyEditor loadNamedPropertyEditor(ClassLoader loader,
-	String cl)
-  {
-    try {
-      return (PropertyEditor)Class.forName(cl, true, loader).newInstance();
-    }
-    catch (ClassNotFoundException _) {
-    }
-    catch (ClassCastException _) {
-    }
-    catch (IllegalAccessException _) {
-    }
-    catch (InstantiationException _) {
-    }
-    return (null);
+  /**
+   * Set the editor search path.
+   *
+   * @param editorSearchPath the new value for the editor search path.
+   */
+  public static void setEditorSearchPath(String[] editorSearchPath)
+  {
+    synchronized(editorSearchPath)
+      {
+        PropertyEditorManager.editorSearchPath = editorSearchPath;
+      }
   }
 }
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/beans/PropertyEditorSupport.java kaffe/libraries/javalib/java/beans/PropertyEditorSupport.java
--- kaffe_orig/libraries/javalib/java/beans/PropertyEditorSupport.java	2003-09-26 14:19:21.000000000 +1200
+++ kaffe/libraries/javalib/java/beans/PropertyEditorSupport.java	2003-10-11 14:39:08.000000000 +1300
@@ -1,121 +1,213 @@
-package java.beans;
-
-import java.awt.Component;
-import java.awt.Graphics;
-import java.awt.Rectangle;
-import java.util.Enumeration;
-import java.util.Vector;
-
 /*
- * Java core library component.
  *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ * Imported from GNU Classpath by M.Negovanovic
  *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
  */
-public class PropertyEditorSupport
-  implements PropertyEditor
-{
-	private Vector listen;
-	private Object source;
-	private Object value;
-
-protected PropertyEditorSupport()
-	{
-	listen = new Vector();
-	value = null;
-	source = this;
-}
-
-protected PropertyEditorSupport(Object src)
-	{
-	listen = new Vector();
-	value = null;
-	source = src;
-}
-
-public synchronized void addPropertyChangeListener(PropertyChangeListener listener)
-	{
-	listen.addElement(listener);
-}
-
-public void firePropertyChange()
-	{
-	PropertyChangeEvent evt = new PropertyChangeEvent(source, null, null, null);
-
-	Enumeration e = ((Vector)listen.clone()).elements();
-	while (e.hasMoreElements()) {
-		((PropertyChangeListener)e.nextElement()).propertyChange(evt);
-	}
-}
-
-public String getAsText()
-	{
-	try {
-		return ((String)value);
-	}
-	catch (ClassCastException _) {
-		return (null);
-	}
-}
 
-public Component getCustomEditor()
-	{
-	return (null);
-}
-
-public String getJavaInitializationString()
-	{
-	return (null);
-}
 
-public String[] getTags()
-	{
-	return (null);
-}
+/* java.beans.PropertyEditorSupport
+   Copyright (C) 1998 Free Software Foundation, Inc.
 
-public Object getValue()
-	{
-	return (value);
-}
+This file is part of GNU Classpath.
 
-public boolean isPaintable()
-	{
-	return (false);
-}
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
-public void paintValue(Graphics gfx, Rectangle box)
-	{
-	// By default we're not paintable so we do nothing here.
-}
 
-public synchronized void removePropertyChangeListener(PropertyChangeListener listener)
-	{
-	listen.removeElement(listener);
-}
-
-public void setAsText(String text) throws IllegalArgumentException
-{
-	if (value == null || value instanceof String) {
-		setValue(text);
-	}
-	else {
-		throw new IllegalArgumentException();
-	}
-}
+package java.beans;
 
-public void setValue(Object value)
-	{
-	if (getValue() != value) {
-		this.value = value;
-		firePropertyChange();
+/**
+ ** PropertyEditorSupport helps with PropertyEditors,
+ ** implementing base functionality that they usually must
+ ** have but which is a pain to implement.  You may extend
+ ** from this class or use it as a standalone.<P>
+ **
+ ** This class does not do any painting or actual editing.
+ ** For that, you must use or extend it.  See the
+ ** PropertyEditor class for better descriptions of what
+ ** the various methods do.
+ **
+ ** @author John Keiser
+ ** @since JDK1.1
+ ** @version 1.1.0, 29 Jul 1998
+ **/
+
+public class PropertyEditorSupport implements PropertyEditor {
+	Object eventSource;
+	Object val;
+	PropertyChangeSupport pSupport;
+
+	/** Call this constructor when you are deriving from
+	 ** PropertyEditorSupport.
+	 **/
+	protected PropertyEditorSupport() {
+		this.eventSource = this;
+		this.pSupport = new PropertyChangeSupport(this);
+	}
+
+	/** Call this constructor when you are using
+	 ** PropertyEditorSupport as a helper object.
+	 ** @param eventSource the source to use when firing
+	 **        property change events.
+	 **/
+	protected PropertyEditorSupport(Object eventSource) {
+		this.eventSource = eventSource;
+		this.pSupport = new PropertyChangeSupport(this);
+	}
+
+	/** Set the current value of the property.
+	 ** <STRONG>Implementation Note</STRONG> Sun does not
+	 ** state what exactly this version of the method does.
+	 ** Thus, in this implementation, it sets the value, and
+	 ** then if the old and new values are different, it
+	 ** fires a property change event with no property name
+	 ** and the old and new values.
+	 ** @param val the new value for the property.
+	 **/
+	public void setValue(Object val) {
+		Object oldVal = val;
+		this.val = val;
+		if(!oldVal.equals(val)) {
+			pSupport.firePropertyChange(null,oldVal,val);
+		}
+	}
+
+	/** Get the current value of the property.
+	 ** @return the current value of the property.
+	 **/
+	public Object getValue() {
+		return val;
+	}
+
+	/** Get whether this object is paintable or not.
+	 ** @return <CODE>false</CODE>
+	 **/
+	public boolean isPaintable() {
+		return false;
+	}
+
+	/** Paint this object.  This class does nothing in
+	 ** this method.
+	 **/
+	public void paintValue(java.awt.Graphics g, java.awt.Rectangle r) {
+	}
+
+	/** Get the Java initialization String for the current
+	 ** value of the Object.  This class returns gibberish or
+	 ** null (though the spec does not say which).<P>
+	 ** <STRONG>Implementation Note:</STRONG> This class
+	 ** returns the string "@$#^" to make sure the code will
+	 ** be broken, so that you will know to override it when
+	 ** you create your own property editor.
+	 ** @return the Java initialization string.
+	 **/
+	public String getJavaInitializationString() {
+		return "@$#^";
+	}
+
+	/** Get the value as text.
+	 ** In this class, you cannot count on getAsText() doing
+	 ** anything useful, although in this implementation I
+	 ** do toString().
+	 ** @return the value as text.
+	 **/
+	public String getAsText() {
+		return val != null ? val.toString() : "null";
+	}
+
+	/** Set the value as text.
+	 ** In this class, you cannot count on setAsText() doing
+	 ** anything useful across implementations.
+	 ** <STRONG>Implementation Note:</STRONG> In this
+	 ** implementation it checks if the String is "null", and
+	 ** if it is, sets the value to null, otherwise it throws
+	 ** an IllegalArgumentException.
+	 ** @param s the text to convert to a new value.
+	 ** @exception IllegalArgumentException if the text is
+	 **            malformed.
+	 **/
+	public void setAsText(String s) throws IllegalArgumentException {
+		if(s.equals("null")) {
+			setValue(null);
+		} else {
+			throw new IllegalArgumentException();
+		}
+	}
+
+	/** Returns a list of possible choices for the value.
+	 ** @return <CODE>null</CODE>
+	 **/
+	public String[] getTags() {
+		return null;
+	}
+
+	/** Return a custom component to edit the value.
+	 ** @return <CODE>null</CODE> in this class.
+	 **/
+	public java.awt.Component getCustomEditor() {
+		return null;
+	}
+
+	/** Find out whether this property editor supports a
+	 ** custom component to edit its value.
+	 ** @return <CODE>false</CODE> in this class.
+	 **/
+	public boolean supportsCustomEditor() {
+		return false;
+	}
+
+	/** Add a property change listener to this property editor.
+	 ** @param l the listener to add.
+	 **/
+	public void addPropertyChangeListener(PropertyChangeListener l) {
+		pSupport.addPropertyChangeListener(l);
+	}
+
+	/** Remove a property change listener from this property editor.
+	 ** @param l the listener to remove.
+	 **/
+	public void removePropertyChangeListener(PropertyChangeListener l) {
+		pSupport.removePropertyChangeListener(l);
+	}
+
+
+	/** Notify people that we've changed, although we don't
+	 ** tell them just how.  The only thing I can think of to
+	 ** send in the event is the new value (since the old value
+	 ** is unavailable and there is no property name).
+	 ** I confess I do not understand the point of this method.
+	 **/
+	public void firePropertyChange() {
+		pSupport.firePropertyChange(null,null,val);
 	}
 }
 
-public boolean supportsCustomEditor()
-	{
-	return (false);
-}
-}
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/beans/SimpleBeanInfo.java kaffe/libraries/javalib/java/beans/SimpleBeanInfo.java
--- kaffe_orig/libraries/javalib/java/beans/SimpleBeanInfo.java	2003-09-26 14:19:21.000000000 +1200
+++ kaffe/libraries/javalib/java/beans/SimpleBeanInfo.java	2003-10-11 14:39:44.000000000 +1300
@@ -1,69 +1,145 @@
 /*
- * Java core library component.
  *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ * Imported from GNU Classpath by M.Negovanovic
  *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
  */
 
-package java.beans;
 
-import java.awt.Image;
-import java.awt.Toolkit;
-import java.net.URL;
+/* java.beans.SimpleBeanInfo
+   Copyright (C) 1998 Free Software Foundation, Inc.
 
-public class SimpleBeanInfo implements BeanInfo {
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+ 
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
 
-  public BeanDescriptor getBeanDescriptor()
-  {
-    return (null);
-  }
-
-  public EventSetDescriptor[] getEventSetDescriptors()
-  {
-    return (null);
-  }
-
-  public int getDefaultEventIndex()
-  {
-    return (-1);
-  }
-
-  public PropertyDescriptor[] getPropertyDescriptors()
-  {
-    return (null);
-  }
-
-  public int getDefaultPropertyIndex()
-  {
-    return (-1);
-  }
-
-  public MethodDescriptor[] getMethodDescriptors()
-  {
-    return (null);
-  }
-
-  public BeanInfo[] getAdditionalBeanInfo()
-  {
-    return (null);
-  }
-
-  public Image getIcon(int iconKind)
-  {
-    return (null);
-  }
-
-  public Image loadImage(String resourceName)
-  {
-    URL nm = this.getClass().getResource(resourceName);
-    if (nm == null) {
-      return (null);
-    }
-    Image img = Toolkit.getDefaultToolkit().getImage(nm);
-    return (img);
-  }
 
+package java.beans;
+
+import java.awt.*;
+
+/**
+ ** SimpleBeanInfo is a class you may extend to more easily
+ ** provide select information to the Introspector.  It
+ ** implements all of the methods in BeanInfo by returning
+ ** null and forces the Introspector to behave exactly as
+ ** if there were no BeanInfo class at all (Introspecting
+ ** everything).<P>
+ **
+ ** Overriding one or two of these functions
+ ** to give explicit information on only those things you
+ ** wish to give explicit information is perfectly safe,
+ ** and even desirable.<P>
+ **
+ ** See the BeanInfo class for information on what the
+ ** various methods actually do.
+ **
+ ** @author John Keiser
+ ** @since JDK1.1
+ ** @version 1.1.0, 29 Jul 1998
+ ** @see java.beans.BeanInfo
+ **/
+
+public class SimpleBeanInfo implements BeanInfo {
+	/** Force Introspection of the general bean info.
+	 ** @return <CODE>null</CODE>.
+	 **/
+	public BeanDescriptor getBeanDescriptor() {
+		return null;
+	}
+
+	/** Force Introspection of the events this Bean type
+	 ** fires.
+	 ** @return <CODE>null</CODE>
+	 **/
+	public EventSetDescriptor[] getEventSetDescriptors() {
+		return null;
+	}
+
+	/** Say that there is no "default" event set.
+	 ** @return <CODE>-1</CODE>.
+	 **/
+	public int getDefaultEventIndex() {
+		return -1;
+	}
+
+	/** Force Introspection of the Bean properties.
+	 ** @return <CODE>null</CODE>.
+	 **/
+	public PropertyDescriptor[] getPropertyDescriptors() {
+		return null;
+	}
+
+	/** Say that there is no "default" property.
+	 ** @return <CODE>-1</CODE>.
+	 **/
+	public int getDefaultPropertyIndex() {
+		return -1;
+	}
+
+	/** Force Introspection of the Bean's methods.
+	 ** @return <CODE>null</CODE>.
+	 **/
+	public MethodDescriptor[] getMethodDescriptors() {
+		return null;
+	}
+
+	/** Tell the Introspector to go look for other BeanInfo
+	 ** itself.
+	 ** @return <CODE>null</CODE>.
+	 **/
+	public BeanInfo[] getAdditionalBeanInfo() {
+		return null;
+	}
+
+	/** Say that this Bean has no icons.
+	 ** @param iconType the type of icon
+	 ** @return <CODE>null</CODE>.
+	 **/
+	public Image getIcon(int iconType) {
+		return null;
+	}
+
+	/** Helper method to load an image using the Bean class
+	 ** getResource() method on the BeanInfo class (using
+	 ** getClass(), since you'll extend this class to get
+	 ** the BeanInfo).  Basically it's assumed that the Bean
+	 ** and its BeanInfo are both loaded by the same
+	 ** ClassLoader, generally a reasonable assumption.
+	 ** @param location the URL relative
+	 ** @return the Image in question.
+	 **/
+	public Image loadImage(String location) {
+		return Toolkit.getDefaultToolkit().getImage(getClass().getResource(location));
+	}
 }
+
diff -Nru -x CVS kaffe_orig/libraries/javalib/java/beans/VetoableChangeSupport.java kaffe/libraries/javalib/java/beans/VetoableChangeSupport.java
--- kaffe_orig/libraries/javalib/java/beans/VetoableChangeSupport.java	2003-09-26 14:19:21.000000000 +1200
+++ kaffe/libraries/javalib/java/beans/VetoableChangeSupport.java	2003-10-11 14:40:50.000000000 +1300
@@ -1,91 +1,537 @@
 /*
- * Java core library component.
  *
- * Copyright (c) 1997, 1998
- *      Transvirtual Technologies, Inc.  All rights reserved.
+ * Imported from GNU Classpath by M.Negovanovic
  *
- * See the file "license.terms" for information on usage and redistribution
- * of this file.
  */
 
+
+/* VetoableChangeSupport.java -- support to manage vetoable change listeners
+   Copyright (C) 1998, 1999, 2000, 2002 Free Software Foundation, Inc.
+
+This file is part of GNU Classpath.
+
+GNU Classpath is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2, or (at your option)
+any later version.
+
+GNU Classpath is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GNU Classpath; see the file COPYING.  If not, write to the
+Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+02111-1307 USA.
+
+Linking this library statically or dynamically with other modules is
+making a combined work based on this library.  Thus, the terms and
+conditions of the GNU General Public License cover the whole
+combination.
+
+As a special exception, the copyright holders of this library give you
+permission to link this library with independent modules to produce an
+executable, regardless of the license terms of these independent
+modules, and to copy and distribute the resulting executable under
+terms of your choice, provided that you also meet, for each linked
+independent module, the terms and conditions of the license of that
+module.  An independent module is a module which is not derived from
+or based on this library.  If you modify this library, you may extend
+this exception to your version of the library, but you are not
+obligated to do so.  If you do not wish to do so, delete this
+exception statement from your version. */
+
+
 package java.beans;
 
+import java.io.IOException;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
 import java.io.Serializable;
-import java.util.HashMap;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Hashtable;
+import java.util.Iterator;
+import java.util.Map.Entry;
 import java.util.Vector;
 
-public class VetoableChangeSupport implements Serializable {
-
+/**
+ * VetoableChangeSupport makes it easy to fire vetoable change events and
+ * handle listeners. It allows chaining of listeners, as well as filtering
+ * by property name. In addition, it will serialize only those listeners
+ * which are serializable, ignoring the others without problem. This class
+ * is thread-safe.
+ *
+ * @author John Keiser
+ * @author Eric Blake <ebb9@email.byu.edu>
+ * @since 1.1
+ * @status updated to 1.4
+ */
+public class VetoableChangeSupport implements Serializable
+{
+  /**
+   * Compatible with JDK 1.1+.
+   */
   private static final long serialVersionUID = -5090210921595982017L;
-  private final HashMap PROPERTY_LISTENERS = new HashMap();
-  private Object source;
 
-  public VetoableChangeSupport(Object sourceBean)
+  /**
+   * Maps property names (String) to named listeners (VetoableChangeSupport).
+   * If this is a child instance, this field will be null.
+   *
+   * @serial the map of property names to named listener managers
+   * @since 1.2
+   */
+  private Hashtable children;
+
+  /**
+   * The non-null source object for any generated events.
+   *
+   * @serial the event source
+   */
+  private final Object source;
+
+  /**
+   * A field to compare serialization versions - this class uses version 2.
+   *
+   * @serial the serialization format
+   */
+  private final int vetoableChangeSupportSerializedDataVersion = 2;
+
+  /**
+   * The list of all registered vetoable listeners. If this instance was
+   * created by user code, this only holds the global listeners (ie. not tied
+   * to a name), and may be null. If it was created by this class, as a
+   * helper for named properties, then this vector will be non-null, and this
+   * instance appears as a value in the <code>children</code> hashtable of
+   * another instance, so that the listeners are tied to the key of that
+   * hashtable entry.
+   */
+  private transient Vector listeners;
+
+  /**
+   * Create a VetoableChangeSupport to work with a specific source bean.
+   *
+   * @param source the source bean to use
+   * @throws NullPointerException if source is null
+   */
+  public VetoableChangeSupport(Object source)
   {
-    source = sourceBean;
+    this.source = source;
+    if (source == null)
+      throw new NullPointerException();
   }
 
-  public synchronized void addVetoableChangeListener(String property, VetoableChangeListener listener)
+  /**
+   * Adds a VetoableChangeListener to the list of global listeners. All
+   * vetoable change events will be sent to this listener. The listener add
+   * is not unique: that is, <em>n</em> adds with the same listener will
+   * result in <em>n</em> events being sent to that listener for every
+   * vetoable change. Adding a null listener may cause a NullPointerException
+   * down the road. This method will unwrap a VetoableChangeListenerProxy,
+   * registering the underlying delegate to the named property list.
+   *
+   * @param l the listener to add
+   */
+  public synchronized void addVetoableChangeListener(VetoableChangeListener l)
   {
-      if (!PROPERTY_LISTENERS.containsKey(property)) {
-	  PROPERTY_LISTENERS.put(property, new Vector());
+    if (l instanceof VetoableChangeListenerProxy)
+      {
+        VetoableChangeListenerProxy p = (VetoableChangeListenerProxy) l;
+        addVetoableChangeListener(p.propertyName,
+                                  (VetoableChangeListener) p.getListener());
+      }
+    else
+      {
+        if (listeners == null)
+          listeners = new Vector();
+        listeners.add(l);
       }
+  }
 
-      ((Vector) PROPERTY_LISTENERS.get(property)).addElement(listener);
+  /**
+   * Removes a VetoableChangeListener from the list of global listeners. If
+   * any specific properties are being listened on, they must be deregistered
+   * by themselves; this will only remove the general listener to all
+   * properties. If <code>add()</code> has been called multiple times for a
+   * particular listener, <code>remove()</code> will have to be called the
+   * same number of times to deregister it. This method will unwrap a
+   * VetoableChangeListenerProxy, removing the underlying delegate from the
+   * named property list.
+   *
+   * @param l the listener to remove
+   */
+  public synchronized void
+    removeVetoableChangeListener(VetoableChangeListener l)
+  {
+    if (l instanceof VetoableChangeListenerProxy)
+      {
+        VetoableChangeListenerProxy p = (VetoableChangeListenerProxy) l;
+        removeVetoableChangeListener(p.propertyName,
+                                     (VetoableChangeListener) p.getListener());
+      }
+    else if (listeners != null)
+      {
+        listeners.remove(l);
+        if (listeners.isEmpty())
+          listeners = null;
+      }
   }
 
-  public synchronized void addVetoableChangeListener(VetoableChangeListener listener)
+  /**
+   * Returns an array of all registered vetoable change listeners. Those that
+   * were registered under a name will be wrapped in a
+   * <code>VetoableChangeListenerProxy</code>, so you must check whether the
+   * listener is an instance of the proxy class in order to see what name the
+   * real listener is registered under. If there are no registered listeners,
+   * this returns an empty array.
+   *
+   * @return the array of registered listeners
+   * @see VetoableChangeListenerProxy
+   * @since 1.4
+   */
+  public synchronized VetoableChangeListener[] getVetoableChangeListeners()
   {
-      addVetoableChangeListener(null, listener);
+    ArrayList list = new ArrayList();
+    if (listeners != null)
+      list.addAll(listeners);
+    if (children != null)
+      {
+        int i = children.size();
+        Iterator iter = children.entrySet().iterator();
+        while (--i >= 0)
+          {
+            Entry e = (Entry) iter.next();
+            String name = (String) e.getKey();
+            Vector v = ((VetoableChangeSupport) e.getValue()).listeners;
+            int j = v.size();
+            while (--j >= 0)
+              list.add(new VetoableChangeListenerProxy
+                (name, (VetoableChangeListener) v.get(j)));
+          }
+      }
+    return (VetoableChangeListener[])
+      list.toArray(new VetoableChangeListener[list.size()]);
   }
 
-  public synchronized void removeVetoableChangeListener(VetoableChangeListener listener)
+  /**
+   * Adds a VetoableChangeListener listening on the specified property. Events
+   * will be sent to the listener only if the property name matches. The
+   * listener add is not unique; that is, <em>n</em> adds on a particular
+   * property for a particular listener will result in <em>n</em> events
+   * being sent to that listener when that property is changed. The effect is
+   * cumulative, too; if you are registered to listen to receive events on
+   * all vetoable changes, and then you register on a particular property,
+   * you will receive change events for that property twice. Adding a null
+   * listener may cause a NullPointerException down the road. This method
+   * will unwrap a VetoableChangeListenerProxy, registering the underlying
+   * delegate to the named property list if the names match, and discarding
+   * it otherwise.
+   *
+   * @param propertyName the name of the property to listen on
+   * @param l the listener to add
+   * @throws NullPointerException if propertyName is null
+   */
+  public synchronized void addVetoableChangeListener(String propertyName,
+                                                     VetoableChangeListener l)
   {
-      removeVetoableChangeListener(null, listener);
+    while (l instanceof VetoableChangeListenerProxy)
+      {
+        VetoableChangeListenerProxy p = (VetoableChangeListenerProxy) l;
+        if (propertyName == null ? p.propertyName != null
+            : ! propertyName.equals(p.propertyName))
+          return;
+        l = (VetoableChangeListener) p.getListener();
+      }
+    VetoableChangeSupport s = null;
+    if (children == null)
+      children = new Hashtable();
+    else
+      s = (VetoableChangeSupport) children.get(propertyName);
+    if (s == null)
+      {
+        s = new VetoableChangeSupport(source);
+        s.listeners = new Vector();
+        children.put(propertyName, s);
+      }
+    s.listeners.add(l);
   }
 
-  public synchronized void removeVetoableChangeListener(String property, VetoableChangeListener listener)
+  /**
+   * Removes a VetoableChangeListener from listening to a specific property.
+   * If <code>add()</code> has been called multiple times for a particular
+   * listener on a property, <code>remove()</code> will have to be called the
+   * same number of times to deregister it. This method will unwrap a
+   * VetoableChangeListenerProxy, removing the underlying delegate from the
+   * named property list if the names match.
+   *
+   * @param propertyName the property to stop listening on
+   * @param l the listener to remove
+   * @throws NullPointerException if propertyName is null
+   */
+  public synchronized void
+    removeVetoableChangeListener(String propertyName, VetoableChangeListener l)
   {
-      if (PROPERTY_LISTENERS.containsKey(property)) {
-	  ((Vector) PROPERTY_LISTENERS.get(property)).removeElement(listener);
+    if (children == null)
+      return;
+    VetoableChangeSupport s
+      = (VetoableChangeSupport) children.get(propertyName);
+    if (s == null)
+      return;
+    while (l instanceof VetoableChangeListenerProxy)
+      {
+        VetoableChangeListenerProxy p = (VetoableChangeListenerProxy) l;
+        if (propertyName == null ? p.propertyName != null
+            : ! propertyName.equals(p.propertyName))
+          return;
+        l = (VetoableChangeListener) p.getListener();
+      }
+    s.listeners.remove(l);
+    if (s.listeners.isEmpty())
+      {
+        children.remove(propertyName);
+        if (children.isEmpty())
+          children = null;
       }
   }
 
-  public void fireVetoableChange(String propertyName, Object oldValue, Object newValue) throws PropertyVetoException
+  /**
+   * Returns an array of all vetoable change listeners registered under the
+   * given property name. If there are no registered listeners, this returns
+   * an empty array.
+   *
+   * @return the array of registered listeners
+   * @throws NullPointerException if propertyName is null
+   * @since 1.4
+   */
+  public synchronized VetoableChangeListener[]
+    getVetoableChangeListeners(String propertyName)
+  {
+    if (children == null)
+      return new VetoableChangeListener[0];
+    VetoableChangeSupport s
+      = (VetoableChangeSupport) children.get(propertyName);
+    if (s == null)
+      return new VetoableChangeListener[0];
+    return (VetoableChangeListener[])
+      s.listeners.toArray(new VetoableChangeListener[s.listeners.size()]);
+  }
+
+  /**
+   * Fire a PropertyChangeEvent containing the old and new values of the
+   * property to all the global listeners, and to all the listeners for the
+   * specified property name. This does nothing if old and new are non-null
+   * and equal. If the change is vetoed, a new event is fired to notify
+   * listeners about the rollback before the exception is thrown.
+   *
+   * @param propertyName the name of the property that changed
+   * @param oldVal the old value
+   * @param newVal the new value
+   * @throws PropertyVetoException if the change is vetoed by a listener
+   */
+  public void fireVetoableChange(String propertyName,
+                                 Object oldVal, Object newVal)
+    throws PropertyVetoException
+  {
+    fireVetoableChange(new PropertyChangeEvent(source, propertyName,
+                                               oldVal, newVal));
+  }
+
+  /**
+   * Fire a PropertyChangeEvent containing the old and new values of the
+   * property to all the global listeners, and to all the listeners for the
+   * specified property name. This does nothing if old and new are equal.
+   * If the change is vetoed, a new event is fired to notify listeners about
+   * the rollback before the exception is thrown.
+   *
+   * @param propertyName the name of the property that changed
+   * @param oldVal the old value
+   * @param newVal the new value
+   * @throws PropertyVetoException if the change is vetoed by a listener
+   */
+  public void fireVetoableChange(String propertyName, int oldVal, int newVal)
+    throws PropertyVetoException
   {
-    // Check for equality.
-    if (oldValue != null && oldValue.equals(newValue)) {
+    if (oldVal != newVal)
+      fireVetoableChange(new PropertyChangeEvent(source, propertyName,
+                                                 new Integer(oldVal),
+                                                 new Integer(newVal)));
+  }
+
+  /**
+   * Fire a PropertyChangeEvent containing the old and new values of the
+   * property to all the global listeners, and to all the listeners for the
+   * specified property name. This does nothing if old and new are equal.
+   * If the change is vetoed, a new event is fired to notify listeners about
+   * the rollback before the exception is thrown.
+   *
+   * @param propertyName the name of the property that changed
+   * @param oldVal the old value
+   * @param newVal the new value
+   * @throws PropertyVetoException if the change is vetoed by a listener
+   */
+  public void fireVetoableChange(String propertyName,
+                                 boolean oldVal, boolean newVal)
+    throws PropertyVetoException
+  {
+    if (oldVal != newVal)
+      fireVetoableChange(new PropertyChangeEvent(source, propertyName,
+                                                 Boolean.valueOf(oldVal),
+                                                 Boolean.valueOf(newVal)));
+  }
+
+  /**
+   * Fire a PropertyChangeEvent to all the global listeners, and to all the
+   * listeners for the specified property name. This does nothing if old and
+   * new values of the event are equal. If the change is vetoed, a new event
+   * is fired to notify listeners about the rollback before the exception is
+   * thrown.
+   *
+   * @param event the event to fire
+   * @throws NullPointerException if event is null
+   * @throws PropertyVetoException if the change is vetoed by a listener
+   */
+  public void fireVetoableChange(PropertyChangeEvent event)
+    throws PropertyVetoException
+  {
+    if (event.oldValue != null && event.oldValue.equals(event.newValue))
       return;
-    }
+    Vector v = listeners; // Be thread-safe.
+    if (v != null)
+      {
+        int i = v.size();
+        try
+          {
+            while (--i >= 0)
+              ((VetoableChangeListener) v.get(i)).vetoableChange(event);
+          }
+        catch (PropertyVetoException e)
+          {
+            event = event.rollback();
+            int limit = i;
+            i = v.size();
+            while (--i >= limit)
+              ((VetoableChangeListener) v.get(i)).vetoableChange(event);
+            throw e;
+          }
+      }
+    Hashtable h = children; // Be thread-safe.
+    if (h != null && event.propertyName != null)
+      {
+        VetoableChangeSupport s
+          = (VetoableChangeSupport) h.get(event.propertyName);
+        if (s != null)
+          {
+            Vector v1 = s.listeners; // Be thread-safe.
+            int i = v1 == null ? 0 : v1.size();
+            try
+              {
+                while (--i >= 0)
+                  ((VetoableChangeListener) v1.get(i)).vetoableChange(event);
+              }
+            catch (PropertyVetoException e)
+              {
+                event = event.rollback();
+                int limit = i;
+                i = v.size();
+                while (--i >= 0)
+                  ((VetoableChangeListener) v.get(i)).vetoableChange(event);
+                i = v1.size();
+                while (--i >= limit)
+                  ((VetoableChangeListener) v1.get(i)).vetoableChange(event);
+                throw e;
+              }
+          }
+      }
+  }
+
+  /**
+   * Tell whether the specified property is being listened on or not. This
+   * will only return <code>true</code> if there are listeners on all
+   * properties or if there is a listener specifically on this property.
+   *
+   * @param propertyName the property that may be listened on
+   * @return whether the property is being listened on
+   * @throws NullPointerException if propertyName is null
+   */
+  public synchronized boolean hasListeners(String propertyName)
+  {
+    return listeners != null || (children != null
+                                 && children.get(propertyName) != null);
+  }
 
-    if (!PROPERTY_LISTENERS.containsKey(null)
-	&& !PROPERTY_LISTENERS.containsKey(propertyName)) { 
-	    return;
-    }
-
-    // Clone the set of listeners to avoid synchronization problems.
-    Vector vec = (Vector) ((Vector) PROPERTY_LISTENERS.get(propertyName)).clone();
-    vec.addAll((Vector) PROPERTY_LISTENERS.get(null));
-
-    // Dispatch.  We catch the Veto exception so we can undo our changes
-    int dispatch = 0;
-    try {
-      PropertyChangeEvent evt = new PropertyChangeEvent(source, propertyName, oldValue, newValue);
-      for (; dispatch < vec.size(); dispatch++) {
-        ((VetoableChangeListener)vec.elementAt(dispatch)).vetoableChange(evt);
-      }
-    }
-    catch (PropertyVetoException _) {
-      PropertyChangeEvent evt = new PropertyChangeEvent(source, propertyName, newValue, oldValue);
-      for (int i = 0; i < dispatch; i++) {
-        try {
-          ((VetoableChangeListener)vec.elementAt(i)).vetoableChange(evt);
-	}
-        catch (PropertyVetoException ignore) {
-	  // Just ignore these.
-        }
+  /**
+   * Saves the state of the object to the stream.
+   *
+   * @param s the stream to write to
+   * @throws IOException if anything goes wrong
+   * @serialData this writes out a null-terminated list of serializable
+   *             global vetoable change listeners (the listeners for a named
+   *             property are written out as the global listeners of the
+   *             children, when the children hashtable is saved)
+   */
+  private synchronized void writeObject(ObjectOutputStream s)
+    throws IOException
+  {
+    s.defaultWriteObject();
+    if (listeners != null)
+      {
+        int i = listeners.size();
+        while (--i >= 0)
+          if (listeners.get(i) instanceof Serializable)
+            s.writeObject(listeners.get(i));
       }
-    }
+    s.writeObject(null);
   }
 
-}
+  /**
+   * Reads the object back from stream (deserialization).
+   *
+   * XXX Since serialization for 1.1 streams was not documented, this may
+   * not work if vetoableChangeSupportSerializedDataVersion is 1.
+   *
+   * @param s the stream to read from
+   * @throws IOException if reading the stream fails
+   * @throws ClassNotFoundException if deserialization fails
+   * @serialData this reads in a null-terminated list of serializable
+   *             global vetoable change listeners (the listeners for a named
+   *             property are written out as the global listeners of the
+   *             children, when the children hashtable is saved)
+   */
+  private void readObject(ObjectInputStream s)
+    throws IOException, ClassNotFoundException
+  {
+    s.defaultReadObject();
+    VetoableChangeListener l = (VetoableChangeListener) s.readObject();
+    while (l != null)
+      {
+        addVetoableChangeListener(l);
+        l = (VetoableChangeListener) s.readObject();
+      }
+    // Sun is not as careful with children as we are, and lets some proxys
+    // in that can never receive events. So, we clean up anything that got
+    // serialized, to make sure our invariants hold.
+    if (children != null)
+      {
+        int i = children.size();
+        Iterator iter = children.entrySet().iterator();
+        while (--i >= 0)
+          {
+            Entry e = (Entry) iter.next();
+            String name = (String) e.getKey();
+            VetoableChangeSupport vcs = (VetoableChangeSupport) e.getValue();
+            if (vcs.listeners == null)
+              vcs.listeners = new Vector();
+            if (vcs.children != null)
+              vcs.listeners.addAll
+                (Arrays.asList(vcs.getVetoableChangeListeners(name)));
+            if (vcs.listeners.size() == 0)
+              iter.remove();
+            else
+              vcs.children = null;
+          }
+        if (children.size() == 0)
+          children = null;
+      }
+  }
+} // class VetoableChangeSupport
diff -Nru -x CVS kaffe_orig/libraries/javalib/profiles/allatonce/all.files kaffe/libraries/javalib/profiles/allatonce/all.files
--- kaffe_orig/libraries/javalib/profiles/allatonce/all.files	2003-10-10 10:59:30.000000000 +1300
+++ kaffe/libraries/javalib/profiles/allatonce/all.files	2003-10-11 09:43:34.000000000 +1300
@@ -624,7 +624,6 @@
 java/beans/EventSetDescriptor.java
 java/beans/ExceptionListener.java
 java/beans/FeatureDescriptor.java
-java/beans/GenericBeanInfo.java
 java/beans/IndexedPropertyDescriptor.java
 java/beans/IntrospectionException.java
 java/beans/Introspector.java
diff -Nru -x CVS kaffe_orig/libraries/javalib/profiles/default/rest.files kaffe/libraries/javalib/profiles/default/rest.files
--- kaffe_orig/libraries/javalib/profiles/default/rest.files	2003-10-10 10:59:30.000000000 +1300
+++ kaffe/libraries/javalib/profiles/default/rest.files	2003-10-11 09:44:59.000000000 +1300
@@ -189,7 +189,6 @@
 java/beans/PropertyEditor.java
 java/beans/ExceptionListener.java
 java/beans/PropertyChangeListenerProxy.java
-java/beans/GenericBeanInfo.java
 java/beans/Customizer.java
 java/util/logging/LogRecord.java
 java/util/logging/Logger.java
--- kaffe_orig/test/regression/Bean.java	2003-09-26 14:18:04.000000000 +1200
+++ kaffe/test/regression/Bean.java	2003-10-11 23:02:10.000000000 +1300
@@ -61,7 +61,7 @@
   Class: class Bean
   Editor: <unknown>
   Editor: <unknown>
-  Editor: class kaffe.beans.editors.StringEditor
+  Editor: class gnu.java.beans.editors.StringEditor
   Method: public boolean java.lang.Object.equals(java.lang.Object)
   Method: public final native java.lang.Class java.lang.Object.getClass()
   Method: public final native void java.lang.Object.notify()
@@ -74,7 +74,6 @@
   Method: public java.lang.String java.lang.Object.toString()
   Method: public java.lang.String[] Bean.getArray()
   Method: public native int java.lang.Object.hashCode()
-  Method: public static void Bean.main(java.lang.String[])
   Method: public void Bean.setArray(int,java.lang.String)
   Method: public void Bean.setArray(java.lang.String[])
   Method: public void Bean.setValue(java.lang.String)
